CREATE TEMPORARY TABLE sip_backup(id INTEGER PRIMARY KEY , name VARCHAR(60), server_address VARCHAR(60), user VARCHAR(60), secret VARCHAR(60), type VARCHAR(60) NOT NULL DEFAULT  '', def INTEGER DEFAULT 0);
INSERT INTO sip_backup SELECT * from sip;
DROP TABLE sip;
CREATE TABLE sip ( id INTEGER PRIMARY KEY , name VARCHAR(60), server_address VARCHAR(60), user VARCHAR(60), secret VARCHAR(60), type VARCHAR(60) NOT NULL DEFAULT  '', def INTEGER DEFAULT 0, config VARCHAR(255) DEFAULT '');
INSERT INTO sip (id,name,server_address,user,secret,type,def) SELECT * FROM sip_backup;
DROP TABLE sip_backup;

CREATE TEMPORARY TABLE general_backup(id INTEGER PRIMARY KEY , logserver VARCHAR(60) NOT NULL DEFAULT  '', logging_active INTEGER NOT NULL DEFAULT  1, msp_device_ip VARCHAR(60), loglevel INTEGER DEFAULT 0);
INSERT INTO general_backup SELECT id,logserver,logging_active,msp_device_ip,loglevel FROM general;
CREATE TEMPORARY TABLE udpports_backup(udpports VARCHAR(255));
INSERT INTO udpports_backup SELECT udpports FROM general;
DROP TABLE general;
CREATE TABLE general ( id INTEGER PRIMARY KEY , logserver VARCHAR(60) NOT NULL DEFAULT  '', logging_active INTEGER NOT NULL DEFAULT  1, msp_device_ip VARCHAR(60), loglevel INTEGER DEFAULT 0);
INSERT INTO general SELECT * FROM general_backup;
CREATE TABLE sip_general ( id INTEGER PRIMARY KEY , udpports VARCHAR(255), bindport VARCHAR(50) DEFAULT '');
INSERT INTO sip_general (udpports) SELECT * FROM udpports_backup;
UPDATE sip_general set bindport='5060';
DROP TABLE general_backup;
DROP TABLE udpports_backup;
CREATE TABLE version (id INTEGER PRIMARY KEY, vnum INTEGER);
INSERT INTO version (vnum) VALUES(0);

VERSION 0

CREATE TABLE set_app (show_app INTEGER DEFAULT 0);
INSERT INTO set_app (show_app) VALUES(0);

VERSION 1

CREATE TEMPORARY TABLE isdn_backup(type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY,
gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te',
ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1',
clock VARCHAR(1) NOT NULL DEFAULT '0');
insert into isdn_backup SELECT * from isdn;
DROP TABLE isdn;
CREATE TABLE isdn ( type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te',  ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]');
insert into isdn (type,lif,port,gr,ptp,ntteHW,ntteSW,config,lt,clock) SELECT * FROM isdn_backup;
DROP TABLE isdn_backup;

VERSION 2

CREATE TEMPORARY TABLE sip_backup ( id INTEGER PRIMARY KEY , name VARCHAR(60), server_address VARCHAR(60), 
user VARCHAR(60), secret VARCHAR(60), type VARCHAR(60) NOT NULL DEFAULT  '', def INTEGER DEFAULT 0,
config VARCHAR(255) DEFAULT '');
INSERT INTO sip_backup SELECT * from sip;
DROP TABLE sip;
CREATE TABLE sip ( id INTEGER PRIMARY KEY , name VARCHAR(60), server_address VARCHAR(60), user VARCHAR(60), secret VARCHAR(60), type VARCHAR(60) NOT NULL DEFAULT  '', def INTEGER DEFAULT 0, config VARCHAR(255) DEFAULT '', stunserver VARCHAR(25) NOT NULL DEFAULT "", externip VARCHAR(25) NOT NULL DEFAULT "");
INSERT INTO sip (id,name,server_address,user,secret,type,def,config) SELECT * FROM sip_backup;
DROP TABLE sip_backup;

VERSION 3

CREATE TEMPORARY TABLE sip_general_backup ( id INTEGER PRIMARY KEY , udpports VARCHAR(255), bindport VARCHAR(50));
INSERT INTO sip_general_backup SELECT * from sip_general;
DROP TABLE sip_general;
CREATE TABLE sip_general ( id INTEGER PRIMARY KEY , udpports VARCHAR(255), bindport VARCHAR(50), externip VARCHAR(50));
INSERT INTO sip_general (id,udpports,bindport) SELECT * FROM sip_general_backup;
DROP TABLE sip_general_backup;

VERSION 4

CREATE TEMPORARY TABLE isdn_backup(type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te', ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]');
insert into isdn_backup SELECT * from isdn;
DROP TABLE isdn;
CREATE TABLE isdn (type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te', ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]');
insert into isdn SELECT * from isdn_backup;
DROP TABLE isdn_backup;

CREATE TEMPORARY TABLE sip_backup ( id INTEGER PRIMARY KEY , name VARCHAR(60), server_address VARCHAR(60), user VARCHAR(60), secret VARCHAR(60), type VARCHAR(60) NOT NULL DEFAULT  '', def INTEGER DEFAULT 0, config VARCHAR(255) DEFAULT '', stunserver VARCHAR(25) NOT NULL DEFAULT '', externip VARCHAR(25) NOT NULL DEFAULT '');
INSERT INTO sip_backup SELECT * from sip;
DROP TABLE sip;
CREATE TABLE sip ( id INTEGER PRIMARY KEY , name VARCHAR(60), server_address VARCHAR(60), user VARCHAR(60), secret VARCHAR(60), type VARCHAR(60) NOT NULL DEFAULT  '', def INTEGER DEFAULT 0, config VARCHAR(255) DEFAULT '', stunserver VARCHAR(25) NOT NULL DEFAULT '', externip VARCHAR(25) NOT NULL DEFAULT '');
INSERT INTO sip SELECT * from sip_backup;
DROP TABLE sip_backup;

VERSION 5

CREATE TEMPORARY TABLE isdn_backup(type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te', ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]');
insert into isdn_backup SELECT * from isdn;
DROP TABLE isdn;
CREATE TABLE isdn (type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te', ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]', odt INTEGER NOT NULL DEFAULT '3', odt_empty_dad INTEGER NOT NULL DEFAULT '15');
insert into isdn(type, lif, port, gr, ptp, ntteHW, ntteSW, config, lt, clock, chansel, tones) select * from isdn_backup;
DROP TABLE isdn_backup;

VERSION 6

CREATE TEMPORARY TABLE isdn_backup(type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te', ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]', odt INTEGER NOT NULL DEFAULT '3', odt_empty_dad INTEGER NOT NULL DEFAULT '15');
insert into isdn_backup SELECT * from isdn;
DROP TABLE isdn;
CREATE TABLE isdn (type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te', ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]', odt INTEGER NOT NULL DEFAULT '3', odt_empty_dad INTEGER NOT NULL DEFAULT '15', master INTEGER NOT NULL DEFAULT '1');
insert into isdn(type, lif , port, gr, ptp, ntteHW, ntteSW, config, lt, clock, chansel, tones, odt, odt_empty_dad) select * from isdn_backup;
DROP TABLE isdn_backup;

VERSION 7

CREATE TABLE key_val ( key VARCHAR(50), value VARCHAR(50));

VERSION 8

CREATE TEMPORARY TABLE dialplan_backup (id INTEGER PRIMARY KEY, direction VARCHAR(15), fromId VARCHAR(60), toId VARCHAR(60), dest VARCHAR(60), newDest VARCHAR(100), src VARCHAR(60), newSrc VARCHAR(100), config VARCHAR(255));
insert into dialplan_backup SELECT * from dialplan;
DROP TABLE dialplan;
CREATE TABLE dialplan (id INTEGER PRIMARY KEY, direction VARCHAR(15), fromId VARCHAR(60), toId VARCHAR(60), dest VARCHAR(60), newDest VARCHAR(100), src VARCHAR(60), newSrc VARCHAR(100), config VARCHAR(255), isdnid VARCHAR(100) NOT NULL DEFAULT '');
insert into dialplan (id, direction, fromId, toId, dest, newDest, src, newSrc, config) select * from dialplan_backup;
DROP TABLE dialplan_backup;

VERSION 9

CREATE TEMPORARY TABLE isdn_backup (type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te', ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]', odt INTEGER NOT NULL DEFAULT '3', odt_empty_dad INTEGER NOT NULL DEFAULT '15', master INTEGER NOT NULL DEFAULT '1');
insert into isdn_backup SELECT * from isdn;
DROP TABLE isdn;
CREATE TABLE isdn (type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te', ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]', odt INTEGER NOT NULL DEFAULT '3', odt_empty_dad INTEGER NOT NULL DEFAULT '15', master INTEGER NOT NULL DEFAULT '1', overlap_dialing VARCHAR(3) NOT NULL DEFAULT '0');
insert into isdn(type, lif , port, gr, ptp, ntteHW, ntteSW, config, lt, clock, chansel, tones, odt, odt_empty_dad, master) select * from isdn_backup;
DROP TABLE isdn_backup;

VERSION 10

CREATE TEMPORARY TABLE general_backup ( id INTEGER PRIMARY KEY , logserver VARCHAR(60) NOT NULL DEFAULT  '', logging_active INTEGER NOT NULL DEFAULT  1, msp_device_ip VARCHAR(60), loglevel INTEGER DEFAULT 0);
insert into general_backup SELECT * from general;
DROP TABLE general;
CREATE TABLE general ( id INTEGER PRIMARY KEY , logserver VARCHAR(60) NOT NULL DEFAULT  '', logging_active INTEGER NOT NULL DEFAULT  1, msp_device_ip VARCHAR(60), loglevel INTEGER DEFAULT 0, telnet_acl VARCHAR (50) DEFAULT '127.0.0.1/32') ;
insert into general (id,logserver,logging_active,msp_device_ip,loglevel) select * from general_backup;
DROP TABLE general_backup;


VERSION 11

CREATE TEMPORARY TABLE isdn_backup (type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te', ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]', odt INTEGER NOT NULL DEFAULT '3', odt_empty_dad INTEGER NOT NULL DEFAULT '15', master INTEGER NOT NULL DEFAULT '1', overlap_dialing VARCHAR(3) NOT NULL DEFAULT '0');
insert into isdn_backup SELECT * from isdn;
DROP TABLE isdn;
CREATE TABLE isdn ( type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te', ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]', odt INTEGER NOT NULL DEFAULT '3', odt_empty_dad INTEGER NOT NULL DEFAULT '15', master INTEGER NOT NULL DEFAULT '1', overlap_dialing VARCHAR(3) NOT NULL DEFAULT '0', qsig VARCHAR (3) NOT NULL DEFAULT '0');
insert into isdn(type, lif , port, gr, ptp, ntteHW, ntteSW, config, lt, clock, chansel, tones, odt, odt_empty_dad, master, overlap_dialing) select * from isdn_backup;
DROP TABLE isdn_backup;

VERSION 12

VERSION 13

VERSION 14
