<?php

session_start();
if ((isset($_SESSION['beroari_username']))&&(($_SESSION['beroari_time']+1200)>time())){
	$_SESSION['beroari_time']=time();

	include "./includes/variables.php";
	include "misc/database.php";
	include "./includes/check.php";	
	
	
	include "includes/variables.php";
	include "includes/Sqlite/Tools.php";
	
	include "includes/password_func.php";
	include "modules/sip.php";
	include "modules/sip_general.php";
	include "modules/isdn.php";
	include "modules/isdn_hw.php";
	include "modules/net_conf.php";
	include "modules/time_conf.php";
	include "modules/dialplan.php";
	include "modules/general.php";
	include "modules/security.php";
	include "modules/update_tool.php";
	include "modules/provisioning.php";
	include "modules/state.php";
	include "modules/state_calls.php";
	include "modules/state_statistic.php";
	include "modules/berofos.php";
	include "modules/info.php";
	if ($_SESSION['beroari_username']=="beroAdmin"){
		include "modules/shell.php";
		$sh=new Shell();
		if ($_GET['m']=="shell")  
		print $sh->display("m=shell,f=display,a=display");
	}
	include "modules/rebres.php";
	include "modules/ddebug.php";
	include "modules/ftrace.php";
	include "modules/back_res.php";


	$e = new Dialplan();
	$sip= new Sip();
	$sipg = new Sip_general();
	$isdn = new Isdn();
	$i_hw = new Isdn_hw();
	$net = new Net_conf();
	$time = new Time_conf();
	$gen= new General();
	$sec= new Sec();
	$up_tool= new Up_tool();
	$prov= new Provisioning();
	$state=new State();
	$sc=new State_calls();
	$ss=new State_Statistic();
	$ddebug=new Dialplandebug();
	$ftrace=new Fulltrace();
	$rebres=new Rebres();
	$info=new Info();
	$berofos=new Berofos();
    $br= new Back_res();


	$m=$_GET["m"];
	$f=$_GET["f"];

	


	if ($m=="dialplan") { 
		print $e->display("m=dialplan,f=display,a=display");
	} elseif ($m=="sip") {
		print $sip->display("m=sip,f=display,a=display");
	} elseif ($m=="sipg") {
		print $sipg->display("m=sipg,f=display,a=display");
	} elseif ($m=="isdn") {
		print $isdn->display("m=new_sip,f=display,a=display");
	} elseif ($m=="isdn_hw") {
		print $i_hw->display("m=isdn_hw,f=display,a=display");
	} elseif ($m=="net_conf") {
		print $net->display("m=net_conf,f=display,a=display");
	} elseif ($m=="time") {
		print $time->display("m=time,f=display,a=display");
	} elseif ($m=="back_res"){
                print $br->display("m=back_res,f=display,a=display");
	} elseif ($m=="ddebug") {
		print $ddebug->display("m=ddebug,f=display,a=display");
	} elseif ($m=="ftrace") {
		print $ftrace->display("m=ftrace,f=display,a=display");
	} elseif ($m=="rebres") {
		print $rebres->display("m=rebres,f=display,a=display");
	} elseif ($m=="info") {
		print $info->display("m=info,f=display,a=display");
	} elseif ($m=="state") {
		print $state->display("m=state,f=display,a=display");
	} elseif ($m=="state_calls") {
		print $sc->display("m=state_calls,f=display,a=display");
	} elseif ($m=="state_statistic") {
		print $ss->display("m=state_statistic,f=display,a=display");
	} elseif (!$m) {
		print $state->display("m=state,f=display,a=display");
	} elseif ($m=="gen"){
		print $gen->display("m=gen,f=display,a=display");
	} elseif ($m=="sec"){
		print $sec->display("m=sec,f=display,a=display");
	} elseif ($m=="up_tool"){
		print $up_tool->display("m=up_tool,f=display,a=display");
	} elseif ($m=="prov"){
		print $prov->display("m=prov,f=display,a=display");
	} elseif ($m=="berofos"){
		print $berofos->display("m=berofos,f=display,a=display");
	}
	
	if (($f=="action")&($m=="dialplan")) {
		print $e->action("m=dialplan,f=action,a=add");
	}elseif (($f=="action")&($m=="sip")){
		print $sip->action("m=sip,f=action,a=add");
	}elseif (($f=="action")&($m=="isdn")){
		print $isdn->action("m=isdn,f=action,a=add");
	}
	
	//if (exec("/bin/cat /proc/RESET_JUMPER")==1){	
		//print ("<script>document.getElementById('reset_jumper').innerHTML='Reset jumper present. Please remove it after you have configured your network settings';</script>");
	//}

chdir("/usr/local/www/berogui");
include("./includes/footer.php");

}elseif(($_SESSION['beroari_time'])&&(($_SESSION['beroari_time']+1200)<time())){
	
	include "./includes/variables.php";
	session_unset();
	session_destroy();
	print '<html><head><link rel="stylesheet" type="text/css" href="http:./includes/template_css.css" />';
	print "<title>beroAri</title></head><body>";
	
	print "<br><table align=\"center\" bgcolor=\"#f0f0ec\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"500\">
	    <colgroup>
	    <col width=\"39\"></col>
	    </colgroup>
		<tbody><tr>
		<td colspan=\"2\"><img src=\"./includes/images/bg_top.png\"></td>
		</tr>
		<tr>
		<td background=\"./includes/images/bg_left.png\" style='background-repeat:repeat-y;' width=\"30\"><img src=\"./includes/images/trans.gif\" height=\"10\" width=\"39\"></td>
		<td><p align='left'><img src=\"./includes/images/berofixlogo.png\"/></p><center><hr size= \"1\" noshade>";

	echo "Session Expired<br>";
	echo $_SESSION['beroari_time']."<br>";
	echo '<a href="./includes/login.php">Login</a>';

	print "<hr size= \"1\" noshade><br/>
	<table align='right'>
	<tr><td>
	<ul id='help'>
	<li><a href='http://www.berofix.com'></a></li>
	</ul>
	</td>
	</tr>
	<tr>
	<td>
	<a href=\"http://www.beronet.com\" target=\"_blank\" onfocus=\"if (this.blur()) { this.blur(); }\">
	<img src=\"./includes/images/beroLogo.gif\" align=\"right\" border=\"0\">
	</a>
	</td>
	</tr>
	</table>";
	print "</center></td></tr>
		<tr>
		<td colspan=\"2\" style=\"background-repeat:no-repeat\" background=\"./includes/images/bg_bottom.png\">
		<img src=\"./includes/images/trans.gif\" border=\"0\" height=\"39\" width=\"10\">
		<div style=\"color: white;\" align=\"right\">" . APPVERSION . "&nbsp;&nbsp;&nbsp;</div>
		</td></tr>";
	print "</body></html>";
}else{
	print "<SCRIPT LANGUAGE='javascript'> location.href = './includes/login.php?m=sip';</SCRIPT><br>";

}

if ($_POST['v']=="Yes" && $_POST['action']=="reboot"){
//	$ret='<h5>Rebooting...<br/>This process will take a few minutes. Click here to reload</h5>';
	print( '<meta http-equiv="Refresh" content="90; url=./index.php">');
	exec ('/sbin/reboot');
}

?>
