<?php
	class beroAri {
		private $db;
		private $dbfile;
		private $err;

		function __construct($path = "") {
			if ($path != "") {
				$this->dbfile = $path;
			} else {
				$this->dbfile = db_path;
			}

			if (is_file($this->dbfile) && filesize($this->dbfile)){
				$this->db = sqlite_open($this->dbfile);
			}else{
				$this->db = sqlite_popen($this->dbfile,0666,$sqlerror);
				$this->create_database();
			}
			if ($this->db == null) {
				$this->err = "Opening " . $this->dbfile . " failed: " . sqlite_error_string(sqlite_last_error($this->db));
				return;
			}
			return;
		}
		
		function __destruct() {
			if ($this->db)
				sqlite_close($this->db);
		}

		function create_database(){
				sqlite_query($this->db,"create table activate (id VARCHAR(15) PRIMARY KEY, option INTEGER DEFAULT 0);");
				sqlite_query($this->db,"INSERT INTO activate VALUES('activate',3);");
				sqlite_query($this->db,"CREATE TABLE users ( id INTEGER PRIMARY KEY , user VARCHAR(20), password VARCHAR(15), group_ VARCHAR(15));");
				sqlite_query($this->db,"INSERT INTO users VALUES(1,'admin','d73b128b9c86524c362ab4420c987827:f2','admin');");
				sqlite_query($this->db,"INSERT INTO users VALUES(2,'beroAdmin','10c1bebe1a569b442d4e423dcf04ee47:f0','admin');");
				sqlite_query($this->db,"CREATE TABLE sip ( id INTEGER PRIMARY KEY , name VARCHAR(60), server_address VARCHAR(60), user VARCHAR(60), secret VARCHAR(60), type VARCHAR(60) NOT NULL DEFAULT  '', def INTEGER DEFAULT 0, config VARCHAR(255), stunserver VARCHAR(25) NOT NULL DEFAULT '', externip VARCHAR(25) NOT NULL DEFAULT '');");
				sqlite_query($this->db,"create table dialplan ( id INTEGER PRIMARY KEY, direction VARCHAR(15), fromId VARCHAR(60), toId VARCHAR(60), dest VARCHAR(60), newDest VARCHAR(100), src VARCHAR(60), newSrc VARCHAR(100), config VARCHAR(255), isdnid VARCHAR(100) NOT NULL DEFAULT '');");
				sqlite_query($this->db,"CREATE TABLE set_app (show_app INTEGER DEFAULT 0);");
				sqlite_query($this->db,"INSERT INTO set_app VALUES(0);");
				sqlite_query($this->db,"CREATE TABLE isdn ( type VARCHAR(30), lif VARCHAR(1), port INTEGER PRIMARY KEY, gr VARCHAR(60) DEFAULT 'NULL', ptp VARCHAR(1) NOT NULL DEFAULT '1', ntteHW VARCHAR(2) NOT NULL DEFAULT 'te', ntteSW VARCHAR(2) NOT NULL DEFAULT 'te', config VARCHAR(255), lt VARCHAR(1) NOT NULL DEFAULT '1', clock VARCHAR(1) NOT NULL DEFAULT '0', chansel VARCHAR(20) NOT NULL DEFAULT 'standard', tones VARCHAR(20) NOT NULL DEFAULT '[de]', odt INTEGER NOT NULL DEFAULT '3', odt_empty_dad INTEGER NOT NULL DEFAULT '15', master INTEGER NOT NULL DEFAULT '1', overlap_dialing VARCHAR(3) NOT NULL DEFAULT '0', qsig VARCHAR (3) NOT NULL DEFAULT '0');");


				$li0=exec('/bin/sed -ne "s/type: \(.*\)/\1/p" /proc/li0');
				if ($li0=="xhfc-4su"){
					for ($i=0;$i<=3;$i++){
						sqlite_query($this->db,"INSERT INTO isdn (type,lif, config) VALUES('bf4S0','0','');");
					}
				}elseif($li0=="hfc-e1"){
					sqlite_query($this->db,"INSERT INTO isdn (type,lif, config) VALUES('bf1E1','0','');");
				}elseif($li0=="hfc-2e1"){
					for ($i=0;$i<=1;$i++){
						sqlite_query($this->db,"INSERT INTO isdn (type,lif, config) VALUES('bf2E1','0','');");
					}
				}
				$li1=exec('/bin/sed -ne "s/type: \(.*\)/\1/p" /proc/li1');
	//			echo "<script>alert('".$li0." ".$li1."')</script>";
				if ($li1=="xhfc-4su"){
					for ($i=0;$i<=3;$i++){
						sqlite_query($this->db,"INSERT INTO isdn (type,lif, config) VALUES('bf4S0','1','');");
					}
				}elseif($li1=="hfc-e1"){
					sqlite_query($this->db,"INSERT INTO isdn (type,lif, config) VALUES('bf1E1','1','');");
				}elseif($li1=="hfc-2e1"){
					for ($i=0;$i<=1;$i++){
						sqlite_query($this->db,"INSERT INTO isdn (type,lif, config) VALUES('bf2E1','1','');");
					}
				}
		
		
				sqlite_query($this->db,"CREATE TABLE key_val ( key VARCHAR(50), value VARCHAR(50));");

				$q=sqlite_query($this->db,"select type, lif from isdn group by type,lif order by lif");
				$i=0;
				while ($ent=sqlite_fetch_array($q)){
					$li[$i]=$ent['lif'];
					$type[$i]=$ent['type'];
					$i++;
				}
				$revision=exec('sed -ne "s/.*revision=\(.*\)/\1/p" /proc/cmdline');
				if ($type[0]=="bf4S0" && !isset($type[1]) && $revision!="1.80"){
					sqlite_query($this->db,"select type, lif from isdn group by type,lif order by lif");
					sqlite_query($this->db,"INSERT into key_val VALUES('portswitch',1)");
				}
				sqlite_query($this->db,"CREATE TABLE general ( id INTEGER PRIMARY KEY , logserver VARCHAR(60) NOT NULL DEFAULT  '', logging_active INTEGER NOT NULL DEFAULT  1, msp_device_ip VARCHAR(60), loglevel INTEGER DEFAULT 0, telnet_acl VARCHAR (50) DEFAULT '127.0.0.1/32');");
				sqlite_query($this->db,"INSERT INTO general VALUES(1,'127.0.0.1:54323',1,'',0,'127.0.0.1/0');");

				sqlite_query($this->db,"CREATE TABLE sip_general ( id INTEGER PRIMARY KEY , udpports VARCHAR(255), bindport VARCHAR(50), externip VARCHAR(50));");
				sqlite_query($this->db,"INSERT INTO sip_general VALUES(1,'5000-5059,5062-6000','5060','');");
				
				sqlite_query($this->db,"CREATE TABLE version (id INTEGER PRIMARY KEY, vnum INTEGER)");
				sqlite_query($this->db,"INSERT INTO version (vnum) VALUES(11)");

		}
		function update($sql) {
			$ok = sqlite_query($this->db, $sql);
			if (!$ok) {
				$this->err = "update() failed: " . sqlite_error_string(sqlite_last_error($this->db));
				return false;
			}
			return $ok;
		}
		
		function set ($key, $value = "" ) { 							
			$sql = "UPDATE key_val SET value = '$value' WHERE key = '$key'"; 
			$ok = sqlite_exec($this->db, $sql);                             
			if (!$ok) {                                                     
					return false;                                           
			}                                                               
			if (sqlite_changes($this->db) == 1)                             
					// update succeeded                                     
					return true;  
			$sql = "INSERT INTO key_val (key, value) VALUES ('$key', '$value')";
			$ok = sqlite_exec($this->db, $sql);                             
			if (!$ok) {                                                     
					return false;                                           
			}                                                               
																			
			return true;                                                    
		}      
		   
 		function get ( $key )                                           
        {
			$sql = "SELECT value FROM key_val WHERE key = '$key'";           
			$res = sqlite_query($this->db, $sql);                           
			if (!$res) {                                                    
					return false;                                           
			}                                                               
																			
			$row = sqlite_fetch_array($res);                                
			if (!$row) {                                                    
					//$this->err = "get() failed: No such key ($key) in table key_val";
					return false;                                           
			}                                                               
																			
			return $row[0];                                                 
        }    
        
		function delete($sql) {
			$ok = sqlite_query($this->db, $sql);
			if (!$ok) {
				$this->err = "update() failed: " . sqlite_error_string(sqlite_last_error($this->db));
				return false;
			}
			return true;
		}
		
		function exec_query($sql) {
			$ok = @sqlite_exec($this->db, $sql);
			if (!$ok) {
				$this->err = "exec() failed: " . sqlite_error_string(sqlite_last_error($this->db));
				return false;
			}
			return true;
		}

		function insert_($sql) {
			$ok = sqlite_query($this->db, $sql);
			if (!$ok) {
				$this->err = "insert() failed: " . "Query= " . $sql . "<br>" . sqlite_error_string(sqlite_last_error($this->db));
				return $this->err;
			}
			return $ok;
		}

		function select($sql) {
			$ok = @sqlite_query($this->db, $sql);
			if (!$ok) {
				$this->err = $sql . " .select() failed: " . sqlite_error_string(sqlite_last_error($this->db));
				return false;
			}
			return $ok;
		}

		function fetch_array($data) {
			$entry = sqlite_fetch_array($data);
			return $entry;
		}

		function rowid() {
			$id = sqlite_last_insert_rowid($this->db);
			return $id;
		}

		function column_type($data) {
			$columns = sqlite_fetch_column_types($data, $this->db);
			return $columns;
		}

		function is_error() {
			return $this->err ? true : false;
		}

		function error() {
			return $this->err ? $this->err : "No error.";
		}
	}
