<?php
@session_start();
if (!isset($_SESSION['beroari_time'])){
	 echo "<script>this.window.close();</script>";
}elseif((isset($_SESSION['beroari_time']))&&(($_SESSION['beroari_time']+1200)<time())){
	@session_unset();
	@session_destroy();
	echo "<script>window.opener.location='../index.php'</script>";
	echo "<script>this.window.close();</script>";
}else{
	$_SESSION['beroari_time']=time();

	chdir("..");
	include './includes/variables.php';
	include './misc/database.php';
	require_once ('./includes/isgwtelnet.php');

	//Liefert ein Array mit den Defaultwerten des Configstrings
	function get_isgw_defaults() {
		$isgw = new isgwtelnet();
		$result=$isgw->isgw_login();
		if ($result!=false){
	        $dialplanc=$isgw->isgw_dialplanconfig();
		$zeilen=split("\n",$dialplanc);
		}
		return $zeilen;
	}
	
	
	function get_difference_from_defaults() {
		foreach (array_keys($_POST) as $key){
			//Wenn die gespeicherte Daten in der POST Variable zu dem configstring gehören 
			if (stripos($key,'config_')!==false){
				$k=str_replace("config_", "", $key);
				$zeilen=get_isgw_defaults();
				foreach ($zeilen as $zeile){
					if (stripos($zeile,'[')===0){
						preg_match("/\[(?<bez>.)\]\[(?<name>.+)\] (?<desc>.+) '(?<def>.*)'/",$zeile,$res);
						if (($res['name']==$k) && ($_POST[$key]!="")){
							if ((($_POST[$key]=="\"\"") || ($_POST[$key]=="\'\'")) && ($config!='')) $config.=",".$res['name']."=";
							elseif 	((($_POST[$key]=="\"\"") || ($_POST[$key]=="\'\'")) && ($config=='')) $config.=$res['name']."=";
							elseif ($config!='' && $_POST[$key]!=$res['def']) $config.=",".$res['name']."=".$_POST[$key];
							elseif ($_POST[$key]!=$res['def']) $config.=$res['name']."=".$_POST[$key];
						}
					}
				}
			}	
		}
		return $config;
	}

	//Liefert das endgültige Configstring
	function parameters($config,$direction){
		if ($direction=="sip-isdn"){
			//EC
			if (!isset($_POST['def_ec'])){
				if (isset($_POST['ec']) && $config!=""){
					$config.=",ec=1";
				}elseif(isset($_POST['ec']) && $config==""){
					$config.="ec=1";
				}elseif(!isset($_POST['ec']) && $config!=""){
					$config.=",ec=0";
				}elseif(!isset($_POST['ec']) && $config==""){
					$config.=",ec=0";
				}
			}
			
			//IGNOREP8
			if (!isset($_POST['def_ignorep8'])){
				if (isset($_POST['ignorep8'])){
					$config.=",ignorep8=1";
				}elseif(!isset($_POST['ignorep8'])){
					$config.=",ignorep8=0";
				}
			}
			
			//EAO
			if (!isset($_POST['def_eao'])){
				if (isset($_POST['eao'])){
					$config.=",eao=1";
				}elseif(!isset($_POST['eao'])){
					$config.=",eao=0";
				}
			}
			
			//GEN_RING_EAO
			if (!isset($_POST['def_gen_ring_eao'])){
				if (isset($_POST['gen_ring_eao'])){
					$config.=",gen_ring_eao=1";
				}elseif(!isset($_POST['gen_ring_eao'])){
					$config.=",gen_ring_eao=0";
				}
			}
			
			//ECTL
			if (!isset($_POST['def_ectL'])){
				if (isset($_POST['ectl']))	
					$config.=",ectl=".$_POST['ectl'];
			}
			
			
			
			//DNUMPLAN
			if (!isset($_POST['def_dnumplan'])){
				if (isset($_POST['dnumplan']))	
					$config.=",dnumplan=".$_POST['dnumplan'];
			}
			
			//RNUMPLAN
			if (!isset($_POST['def_rnumplan'])){
				if (isset($_POST['rnumplan']))	
					$config.=",rnumplan=".$_POST['rnumplan'];
			}
			
			//ONUMPLAN
			if (!isset($_POST['def_onumplan'])){
				if (isset($_POST['onumplan']))	
					$config.=",onumplan=".$_POST['onumplan'];
			}
			
			//CPNNUMPLAN
			if (!isset($_POST['def_cpnnumplan'])){
				if (isset($_POST['cpnnumplan']))	
					$config.=",cpnnumplan=".$_POST['cpnnumplan'];
			}
			
			//UNKNOWNPREFIX
			if (!isset($_POST['def_unknownprefix'])){
				if (isset($_POST['unknownprefix']))	
					$config.=",unknownprefix=".$_POST['unknownprefix'];
			}
			
			//INTERNATIONALPREFIX
			if (!isset($_POST['def_internationalprefix'])){
				if (isset($_POST['internationalprefix']))	
					$config.=",internationalprefix=".$_POST['internationalprefix'];
			}
			
			//NATIONALPREFIX
			if (!isset($_POST['def_nationalprefix'])){
				if (isset($_POST['nationalprefix']))	
					$config.=",nationalprefix=".$_POST['nationalprefix'];
			}
			
			//PRIVATEPREFIX
			if (!isset($_POST['def_privateprefix'])){
				if (isset($_POST['privateprefix']))	
					$config.=",privateprefix=".$_POST['privateprefix'];
			}
			
			//LOCALPREFIX
			if (!isset($_POST['def_locaprefix'])){
				if (isset($_POST['localprefix']))	
					$config.=",localprefix=".$_POST['localprefix'];
			}
			
			//BEARER
			if (!isset($_POST['def_bearer_cap'])){
			if (isset($_POST['bearer_cap']))	
				$config.=",bearer_cap=".$_POST['bearer_cap'];
			}
			
			//SCRENNING
			if (!isset($_POST['def_screen'])){
				if (isset($_POST['screen'])){
					$config.=",screen=1";
				}elseif(!isset($_POST['screen'])){
					$config.=",screen=0";
				}
			}
			
			//PRESENTATION
			if (!isset($_POST['def_pres'])){
				if (isset($_POST['pres'])){
					$config.=",pres=1";
				}elseif(!isset($_POST['pres'])){
					$config.=",pres=0";
				}
			}

			//CALL DEFLECTION
			if (!isset($_POST['def_cd'])){
				if (isset($_POST['cd'])){
					$config.=",cd=1";
				}elseif(!isset($_POST['cd'])){
					$config.=",cd=0";
				}
				
			}
			
			//EA
			if (!isset($_POST['def_ea'])){
				if (isset($_POST['ea'])){
					$config.=",ea=1";
				}elseif(!isset($_POST['ea'])){
					$config.=",ea=0";
				}
				
			}
			
			//T.38
			if (!isset($_POST['def_t38'])){
				if (isset($_POST['t38'])){
					$config.=",t38=1";
				}elseif(!isset($_POST['t38'])){
					$config.=",t38=0";
				}
			}
			
			//IE on SIP
			if (!isset($_POST['def_ie_on_sip'])){
				if (isset($_POST['ie_on_sip'])){
					$config.=",ie_on_sip=1";
				}elseif(!isset($_POST['ie_on_sip'])){
					$config.=",ie_on_sip=0";
				}
			}
			
			//ALLOW_SIP_183_WITHOUT_SDP
			if (!isset($_POST['def_allow_sip_183_without_sdp'])){
				if (isset($_POST['allow_sip_183_without_sdp'])){
					$config.=",allow_sip_183_without_sdp=1";
				}elseif(!isset($_POST['allow_sip_183_without_sdp'])){
					$config.=",allow_sip_183_without_sdp=0";
				}
			}
			
			//WAIT FOR CANCEL
			if (!isset($_POST['def_wait_for_cancel'])){
				if (isset($_POST['wait_for_cancel'])){
					$config.=",wait_for_cancel=1";
				}elseif(!isset($_POST['wait_for_cancel'])){
					$config.=",wait_for_cancel=0";
				}
			}

			
			//CLIR on SIP
			if (!isset($_POST['def_clir_on_sip'])){
				if (isset($_POST['clir_on_sip']))	$config.=",clir_on_sip=".$_POST['clir_on_sip'];
			}
			
			//FROM_ID_SETTING
			if (!isset($_POST['def_from_id_setting'])){
				if (isset($_POST['from_id_setting']))	$config.=",from_id_setting=".$_POST['from_id_setting'];
			}
			
			//DISPLAY_NAME_SETTING
			if (!isset($_POST['def_display_name_setting'])){
				if (isset($_POST['display_name_setting']))	$config.=",display_name_setting=".$_POST['display_name_setting'];
			}
			
			//DTMF
			if (!isset($_POST['def_dtmfmode'])){
				if (isset($_POST['dtmfmode'])) 
					$config.=",dtmfmode=".$_POST['dtmfmode'];
			}
			
			//CODECS
			if (!isset($_POST['def_codecs'])){
				$c="";
				for ($i=0;$i<count($_POST['codecs']);$i++){
					if ($c!="") $c.=":";
					$c.= $_POST['codecs'][$i];
				}
				if (isset($_POST['codecs']) && $defc[$_POST['fromIdSip']]['codecs']!=$c)	
					$config.=",codecs=".$c;
			}
		}elseif ($direction=="isdn-sip"){
			//EC
			if (!isset($_POST['def_ec'])){
				if (isset($_POST['ec']) && $config!=""){
					$config.=",ec=1";
				}elseif(isset($_POST['ec']) && $config==""){
					$config.="ec=1";
				}elseif(!isset($_POST['ec']) && $config!=""){
					$config.=",ec=0";
				}elseif(!isset($_POST['ec']) && $config==""){
					$config.=",ec=0";
				}
			}
			
			//EAO
			if (!isset($_POST['def_eao'])){
				if (isset($_POST['eao'])){
					$config.=",eao=1";
				}elseif(!isset($_POST['eao'])){
					$config.=",eao=0";
				}
			}
			
			//IGNOREP8
			if (!isset($_POST['def_ignorep8'])){
				if (isset($_POST['ignorep8'])){
					$config.=",ignorep8=1";
				}elseif(!isset($_POST['ignorep8'])){
					$config.=",ignorep8=0";
				}
			}
			
			//GEN_RING_EAO
			if (!isset($_POST['def_gen_ring_eao'])){
				if (isset($_POST['gen_ring_eao'])){
					$config.=",gen_ring_eao=1";
				}elseif(!isset($_POST['gen_ring_eao'])){
					$config.=",gen_ring_eao=0";
				}
			}
			
			//ECTL
			if (!isset($_POST['def_ectl'])){
				if (isset($_POST['ectl']))	
					$config.=",ectl=".$_POST['ectl'];
			}
			
			
			//DNUMPLAN
			if (!isset($_POST['def_dnumplan'])){
				if (isset($_POST['dnumplan']))	
					$config.=",dnumplan=".$_POST['dnumplan'];
			}
			
			//RNUMPLAN
			if (!isset($_POST['def_rnumplan'])){
				if (isset($_POST['rnumplan']))	
					$config.=",rnumplan=".$_POST['rnumplan'];
			}
			
			//ONUMPLAN
			if (!isset($_POST['def_onumplan'])){
				if (isset($_POST['onumplan']))	
					$config.=",onumplan=".$_POST['onumplan'];
			}
			
			//CPNNUMPLAN
			if (!isset($_POST['def_cpnnumplan'])){
				if (isset($_POST['cpnnumplan']))	
					$config.=",cpnnumplan=".$_POST['cpnnumplan'];
			}
			
			//UNKNOWNPREFIX
			if (!isset($_POST['def_unknownprefix'])){
				if (isset($_POST['unknownprefix']))	
					$config.=",unknownprefix=".$_POST['unknownprefix'];
			}
			
			//INTERNATIONALPREFIX
			if (!isset($_POST['def_internationalprefix'])){
				if (isset($_POST['internationalprefix']) )	
					$config.=",internationalprefix=".$_POST['internationalprefix'];
			}
			
			//NATIONALPREFIX
			if (!isset($_POST['def_nationalprefix'])){
				if (isset($_POST['nationalprefix']))	
					$config.=",nationalprefix=".$_POST['nationalprefix'];
			}
			
			//PRIVATEPREFIX
			if (!isset($_POST['def_privateprefix'])){
				if (isset($_POST['privateprefix']))	
					$config.=",privateprefix=".$_POST['privateprefix'];
			}
			
			//LOCALPREFIX
			if (!isset($_POST['def_localprefix'])){
				if (isset($_POST['localprefix']))	
					$config.=",localprefix=".$_POST['localprefix'];
			}
			
			//BEARER
			if (!isset($_POST['def_bearer_cap'])){
				if (isset($_POST['bearer_cap']))	
					$config.=",bearer_cap=".$_POST['bearer_cap'];
			}
			
			//SCRENNING
			if (!isset($_POST['def_screen'])){
				if (isset($_POST['screen'])){
					$config.=",screen=1";
				}elseif(!isset($_POST['screen'])){
					$config.=",screen=0";
				}
			}
			
			//PRESENTATION
			if (!isset($_POST['def_pres'])){
				if (isset($_POST['pres'])){
					$config.=",pres=1";
				}elseif(!isset($_POST['pres'])){
					$config.=",pres=0";
				}
			}
		
			//EA
			if (!isset($_POST['def_ea'])){
				if (isset($_POST['ea'])){
					$config.=",ea=1";
				}elseif(!isset($_POST['ea'])){
					$config.=",ea=0";
				}
			}
			
			//T.38
			if (!isset($_POST['def_t38'])){
				if (isset($_POST['t38'])){
					$config.=",t38=1";
				}elseif(!isset($_POST['t38'])){
					$config.=",t38=0";
				}
			}
			
			//IE on SIP
			if (!isset($_POST['def_ie_on_sip'])){
				if (isset($_POST['ie_on_sip'])){
					$config.=",ie_on_sip=1";
				}elseif(!isset($_POST['ie_on_sip'])){
					$config.=",ie_on_sip=0";
				}
			}

			
			//ALLOW_SIP_183_WITHOUT_SDP
			if (!isset($_POST['def_allow_sip_183_without_sdp'])){
				if (isset($_POST['allow_sip_183_without_sdp'])){
					$config.=",allow_sip_183_without_sdp=1";
				}elseif(!isset($_POST['allow_sip_183_without_sdp'])){
					$config.=",allow_sip_183_without_sdp=0";
				}
			}
			
			//WAIT FOR CANCEL
			if (!isset($_POST['def_wait_for_cancel'])){
				if (isset($_POST['wait_for_cancel'])){
					$config.=",wait_for_cancel=1";
				}elseif(!isset($_POST['wait_for_cancel'])){
					$config.=",wait_for_cancel=0";
				}
			}
			
			//CLIR on SIP
			if (!isset($_POST['def_clir_on_sip'])){
				if (isset($_POST['clir_on_sip']))	$config.=",clir_on_sip=".$_POST['clir_on_sip'];
			}
			
			//FROM_ID_SETTING
			if (!isset($_POST['def_from_id_setting'])){
				if (isset($_POST['from_id_setting']))	$config.=",from_id_setting=".$_POST['from_id_setting'];
			}
			
			//DISPLAY_NAME_SETTING
			if (!isset($_POST['def_display_name_setting'])){
				if (isset($_POST['display_name_setting']))	$config.=",display_name_setting=".$_POST['display_name_setting'];
			}
			
			//DTMF
			if (!isset($_POST['def_dtmfmode'])){
				if (isset($_POST['dtmfmode'])) 
					$config.=",dtmfmode=".$_POST['dtmfmode'];
			}
			
			//CALL DEFLECTION
			if (!isset($_POST['def_cd'])){
				if (isset($_POST['cd'])){
					$config.=",cd=1";
				}elseif(!isset($_POST['cd'])){
					$config.=",cd=0";
				}
				
			}
			
			//CODECS
			if (!isset($_POST['def_codecs'])){
				if (isset($_POST['codecs'])){
					$c="";
					for ($i=0;$i<count($_POST['codecs']);$i++){
						if ($c!="") $c.=":";
						$c.= $_POST['codecs'][$i];
					}	
					$config.=",codecs=".$c;
				}
			}
		}elseif ($direction=="isdn-isdn"){
			
			
			//EC
			if (!isset($_POST['def_ec']) && ($_POST['ie_on_sip']!=1 || isset($_POST['def_ie_on_sip']))){
				if (isset($_POST['ec']) && $config!=""){
					$config.=",ec=1";
				}elseif(isset($_POST['ec']) && $config==""){
					$config.="ec=1";
				}elseif(!isset($_POST['ec']) && $config!=""){
					$config.=",ec=0";
				}elseif(!isset($_POST['ec']) && $config==""){
					$config.=",ec=0";
				}
			}
			
			
			if ($_POST['id_upd']) {
			//IE on SIP
			if (!isset($_POST['def_ie_on_sip'])){
				if (isset($_POST['ie_on_sip'])){
					$config.="ie_on_sip=1,ec=0,t38=0,unknownprefix=\\\"\\\",internationalprefix=\\\"\\\",nationalprefix=\\\"\\\",privateprefix=\\\"\\\",localprefix=\\\"\\\"";
				}elseif(!isset($_POST['ie_on_sip'])){
					$config.=",ie_on_sip=0";
				}
			}
			}else{
				$_POST['def_ie_on_sip']=1;
				$_POST['ie_on_sip']=1;
					$config.="ie_on_sip=1,ec=0,t38=0,unknownprefix=\\\"\\\",internationalprefix=\\\"\\\",nationalprefix=\\\"\\\",privateprefix=\\\"\\\",localprefix=\\\"\\\"";
			}
			
			//EAO
			if (!isset($_POST['def_eao'])){
				if (isset($_POST['eao'])){
					$config.=",eao=1";
				}elseif(!isset($_POST['eao'])){
					$config.=",eao=0";
				}
			}
			
			//IGNOREP8
			if (!isset($_POST['def_ignorep8'])){
				if (isset($_POST['ignorep8'])){
					$config.=",ignorep8=1";
				}elseif(!isset($_POST['ignorep8'])){
					$config.=",ignorep8=0";
				}
			}
			
			//GEN_RING_EAO
			if (!isset($_POST['def_gen_ring_eao'])){
				if (isset($_POST['gen_ring_eao'])){
					$config.=",gen_ring_eao=1";
				}elseif(!isset($_POST['gen_ring_eao'])){
					$config.=",gen_ring_eao=0";
				}
			}
			
			//ECTL
			if (!isset($_POST['def_ectL'])){
				if (isset($_POST['ectl']))	
					$config.=",ectl=".$_POST['ectl'];
			}
			
			
			
			//DNUMPLAN
			if (!isset($_POST['def_dnumplan'])){
				if (isset($_POST['dnumplan']))	
					$config.=",dnumplan=".$_POST['dnumplan'];
			}
			
			//RNUMPLAN
			if (!isset($_POST['def_rnumplan'])){
				if (isset($_POST['rnumplan']))	
					$config.=",rnumplan=".$_POST['rnumplan'];
			}
			
			//ONUMPLAN
			if (!isset($_POST['def_onumplan'])){
				if (isset($_POST['onumplan']))	
					$config.=",onumplan=".$_POST['onumplan'];
			}
			
			//CPNNUMPLAN
			if (!isset($_POST['def_cpnnumplan'])){
				if (isset($_POST['cpnnumplan']))	
					$config.=",cpnnumplan=".$_POST['cpnnumplan'];
			}
			
			//UNKNOWNPREFIX
			if (!isset($_POST['def_unknownprefix']) && ($_POST['ie_on_sip']!=1 || isset($_POST['def_ie_on_sip']))){
				if (isset($_POST['unknownprefix']))	
					$config.=",unknownprefix=".$_POST['unknownprefix'];
			}
			
			//INTERNATIONALPREFIX
			if (!isset($_POST['def_internationalprefix']) && ($_POST['ie_on_sip']!=1 || isset($_POST['def_ie_on_sip']))){
				if (isset($_POST['internationalprefix']))	
					$config.=",internationalprefix=".$_POST['internationalprefix'];
			}
			
			//NATIONALPREFIX
			if (!isset($_POST['def_nationalprefix']) && ($_POST['ie_on_sip']!=1 || isset($_POST['def_ie_on_sip']))){
				if (isset($_POST['nationalprefix']))	
					$config.=",nationalprefix=".$_POST['nationalprefix'];
			}
			
			//PRIVATEPREFIX
			if (!isset($_POST['def_privateprefix']) && ($_POST['ie_on_sip']!=1 || isset($_POST['def_ie_on_sip']))){
				if (isset($_POST['privateprefix']))	
					$config.=",privateprefix=".$_POST['privateprefix'];
			}
			
			//LOCALPREFIX
			if (!isset($_POST['def_locaprefix']) && ($_POST['ie_on_sip']!=1 || isset($_POST['def_ie_on_sip']))){
				if (isset($_POST['localprefix']))	
					$config.=",localprefix=".$_POST['localprefix'];
			}
			
			//BEARER
			if (!isset($_POST['def_bearer_cap'])){
			if (isset($_POST['bearer_cap']))	
				$config.=",bearer_cap=".$_POST['bearer_cap'];
			}
			
			//SCRENNING
			if (!isset($_POST['def_screen'])){
				if (isset($_POST['screen'])){
					$config.=",screen=1";
				}elseif(!isset($_POST['screen'])){
					$config.=",screen=0";
				}
			}
			
			//PRESENTATION
			if (!isset($_POST['def_pres'])){
				if (isset($_POST['pres'])){
					$config.=",pres=1";
				}elseif(!isset($_POST['pres'])){
					$config.=",pres=0";
				}
			}
			
			//CALL DEFLECTION
			if (!isset($_POST['def_cd'])){
				if (isset($_POST['cd'])){
					$config.=",cd=1";
				}elseif(!isset($_POST['cd'])){
					$config.=",cd=0";
				}
				
			}
			
		}
		if (stripos($config,",")==0 && stripos($config,",")!==false)
		$config=substr_replace($config,'',0,1);
		return $config;
			
	}

	//Datenbankobjekt erstellen
	$ba = new beroAri();
	$page=$_POST['start'];
	//Wenn einen Eintrag bearbeitet wurde
	if ($_POST['id_upd']) {
		
		//Wenn es richtung sip zu isdn geht
		if ($_POST['from_to'] == 'sip-isdn') {
			$direction="sip-isdn";
			$id=$_POST['id_upd'];
			$fromid=$_POST['fromIdSip'];
			$fromManual=$_POST['manualsipfrom'];
			//if ($fromid=="") $fromid="(.*)";
			$toid=$_POST['toIsdn'];
			$dest=$_POST['dest'];
			//if ($dest=="") $dest="(.*)";
			$newdest=$_POST['newDest'];
			//if ($newdest=="") $newdest="\\\\1";
			$src=$_POST['src'];
			//if ($src=="") $src="(.*)";
			$newsrc=$_POST['newSrc'];
			//if ($newsrc=="") $newsrc="\\\\1";
			$config=get_difference_from_defaults();
			$config=parameters($config,$direction);
			//Wenn der Eintrag davor ein isdn zu isdn Eintrag war, werden die alten Einträge gelöscht und der neue Eintrag wird in der Datenbank angelegt
			if ($_POST['isdnid']!=""){
				$ba->delete("delete from dialplan where isdnid='".$_POST['isdnid']."'");
				if ($fromid!="manual"){
					$qu = $ba->update("insert into dialplan (id, direction, fromId, toId, dest, newDest, src, newSrc, config) VALUES ('$id', '$direction', '$fromid', '$toid', '$dest', '$newdest', '$src', '$newsrc', '$config')");
				}else{
					$qu = $ba->update("insert into dialplan (id, direction, fromId, toId, dest, newDest, src, newSrc, config) VALUES ('$id', '$direction', '$fromManual', '$toid', '$dest', '$newdest', '$src', '$newsrc', '$config')");
				}
			}else{
				if ($fromid!="manual"){
					$query_new = $ba->update("UPDATE dialplan SET direction='$direction', fromId='$fromid', toId='$toid', dest='$dest', newDest='$newdest', src='$src', newSrc='$newsrc', config='$config' WHERE id='$id'");
				}else{
					$query_new = $ba->update("UPDATE dialplan SET direction='$direction', fromId='$fromManual', toId='$toid', dest='$dest', newDest='$newdest', src='$src', newSrc='$newsrc', config='$config' WHERE id='$id'");
				}
			}
		}
		
		//Wenn es richtung isdn zu sip geht
		if ($_POST['from_to'] == 'isdn-sip') {
			$direction="isdn-sip";
			$id=$_POST['id_upd'];
			$fromid=$_POST['fromIdIsdn'];
			$toid=$_POST['toSip'];	
			
			$toManual=$_POST['manualsip'];
			$dest=$_POST['dest'];
			$newdest=$_POST['newDest'];
			$src=$_POST['src'];
			$newsrc=$_POST['newSrc'];
			//if ($dest=="") $dest="(.*)";
			//if ($newdest=="") $newdest="\\\\1";
			//if ($src=="") $src="(.*)";
			//if ($newsrc=="") $newsrc="\\\\1";
			$config=get_difference_from_defaults();
			$config=parameters($config,$direction);
			//Wenn der Eintrag davor ein isdn zu isdn Eintrag war, werden die alten Einträge gelöscht und der neue Eintrag wird in der Datenbank angelegt
			if ($_POST['isdnid']!=""){
				$ba->delete("delete from dialplan where isdnid='".$_POST['isdnid']."'");
				if ($toid!="manual"){
					$qu = $ba->insert_("insert into dialplan (id, direction, fromId, toId, dest, newDest, src, newSrc, config) VALUES ('$id', '$direction', '$fromid', '$toid', '$dest', '$newdest', '$src', '$newsrc', '$config')");
				}else{
					$qu = $ba->insert_("insert into dialplan (id, direction, fromId, toId, dest, newDest, src, newSrc, config) VALUES ('$id', '$direction', '$fromid', '$toManual', '$dest', '$newdest', '$src', '$newsrc', '$config')");
				}
			}else{		
				if ($toid!="manual"){
					$qu = $ba->update("UPDATE dialplan SET direction='$direction', fromId='$fromid', toId='$toid', dest='$dest', newDest='$newdest', src='$src', newSrc='$newsrc', config='$config' WHERE id='$id'");
				}else{
					$q= $ba->update("UPDATE dialplan SET direction='$direction', fromId='$fromid', toId='$toManual', dest='$dest', newDest='$newdest', src='$src', newSrc='$newsrc', config='$config' WHERE id='$id'");
				}
			}
		}
		
		//Wenn es richtung isdn zu isdn geht
		if ($_POST['from_to'] == 'isdn-isdn') {
			$direction="isdn-isdn";
			$id=$_POST['id_upd'];
			$fromid=$_POST['fromIdIsdn'];
			$toid=$_POST['toIsdn'];			
			$dest=$_POST['dest'];
			$newdest=$_POST['newDest'];
			$src=$_POST['src'];
			$newsrc=$_POST['newSrc'];
			$config=get_difference_from_defaults();
			$config=parameters($config,$direction);
			//Wenn der Eintrag davor ein isdn zu isdn Eintrag war, werden die alten Einträge geupdated.
			if ($_POST['isdnid']!=""){
				//$qu=$ba->update("UPDATE dialplan SET fromId='$fromid', toId='127.0.0.1', dest='$dest', newDest='".$_POST['isdnid']."\\\\1', src='$src', newSrc='\\\\1', config='$config' WHERE isdnid='".$_POST['isdnid']."' and direction='isdn-sip'");
				$qu=$ba->update("UPDATE dialplan SET fromId='$fromid', toId='127.0.0.1', dest='$dest', newDest='".$_POST['isdnid'].$newdest."', src='$src', newSrc='$newsrc', config='$config' WHERE isdnid='".$_POST['isdnid']."' and direction='isdn-sip'");
				$qu=$ba->update("UPDATE dialplan SET fromId='127.0.0.1', toId='$toid', dest='".$_POST['isdnid']."(.*)', newDest='\\\\1', src='(.*)', newSrc='\\\\1', config='$config' WHERE isdnid='".$_POST['isdnid']."' and direction='sip-isdn'");
			//Wenn der alte Eintrag nicht von isdn zu isdn geht, wird der Eintrag gelöscht und 2 neue Einträge werden gespeichert.
			}else{
				$ba->delete("delete from dialplan where id='$id'");
				$isdnid=uniqid("ISDNZUISDN");
				$ba->insert_("insert into dialplan (id, direction, fromId, toId, dest, newDest, src, newSrc, config, isdnid) VALUES ('$id', 'isdn-sip', '$fromid', '127.0.0.1', '$dest', '".$isdnid.$newdest."', '$src', '".$newsrc."', '$config', '$isdnid')");
				$ba->insert_("insert into dialplan (direction, fromId, toId, dest, newDest, src, newSrc, config, isdnid) VALUES ('sip-isdn', '127.0.0.1', '$toid', '".$isdnid."(.*)', '\\\\1', '(.*)', '\\\\1', '$config', '$isdnid')");
			}
		}
		$query = $ba->select("select option from activate where id='activate'");
		while ($entry = $ba->fetch_array($query)) {
			if ($entry['option'] <= 1)
				$query = $ba->update("UPDATE activate SET option=1");
		}
		
		if (!$ba->is_error()) {
			$page=$_POST['start'];
			echo "<script>window.opener.location='../index.php?m=dialplan&start=" . $page . "'</script>";
			echo "<script>this.window.close();</script>";

		} else {
			echo "<script>alert('" . $ba->error() . "');</script>";
		}

	} else {
		if ($_POST['from_to'] == 'sip-isdn') {
			$direction="sip-isdn";
			$fromid=$_POST['fromIdSip'];
			$fromManual=$_POST['manualsipfrom'];
			$toid=$_POST['toIsdn'];
			$dest=$_POST['dest'];
			$newdest=$_POST['newDest'];
			$src=$_POST['src'];
			$newsrc=$_POST['newSrc'];
			if ($fromid=="manual" && $fromManual=="")  $fromManual="(.*)";
			if ($dest=="") $dest="(.*)";
			if ($newdest=="") $newdest="\\\\1";
			if ($src=="") $src="(.*)";
			if ($newsrc=="") $newsrc="\\\\1";
			$config=get_difference_from_defaults();
			$config=parameters($config,$direction);
			if ($fromid!="manual"){
				$query_new = $ba->insert_("INSERT INTO dialplan (direction, fromId, toId, dest, newDest, src, newSrc, config) VALUES ('$direction','$fromid','$toid', '$dest', '$newdest', '$src', '$newsrc', '$config')");
			}else{
				$query_new = $ba->insert_("INSERT INTO dialplan (direction, fromId, toId, dest, newDest, src, newSrc, config) VALUES ('$direction','$fromManual','$toid', '$dest', '$newdest', '$src', '$newsrc', '$config')");
			}
		}
		if ($_POST['from_to'] == 'isdn-sip') {
			$direction="isdn-sip";
			$fromid=$_POST['fromIdIsdn'];
			$toid=$_POST['toSip'];	
			$toManual=$_POST['manualsip'];
			$dest=$_POST['dest'];
			$newdest=$_POST['newDest'];
			$src=$_POST['src'];
			$newsrc=$_POST['newSrc'];
			if ($dest=="") $dest="(.*)";
			if ($newdest=="") $newdest="\\\\1";
			if ($src=="") $src="(.*)";
			if ($newsrc=="") $newsrc="\\\\1";
			$config=get_difference_from_defaults();
			$config=parameters($config,$direction);
			if ($toid!="manual"){
				$query_new = $ba->insert_("INSERT INTO dialplan (direction, fromId, toId, dest, newDest, src, newSrc, config) VALUES ('$direction','$fromid','$toid', '$dest', '$newdest', '$src', '$newsrc', '$config')");
			}else{
				$query_new = $ba->insert_("INSERT INTO dialplan (direction, fromId, toId, dest, newDest, src, newSrc, config) VALUES ('$direction','$fromid','$toManual', '$dest', '$newdest', '$src', '$newsrc', '$config')");

			}
		}
		if ($_POST['from_to'] == 'isdn-isdn') {
			$direction="isdn-isdn";
			$fromid=$_POST['fromIdIsdn'];
			$toid=$_POST['toIsdn'];	
			$dest=$_POST['dest'];
			$newdest=$_POST['newDest'];
			$src=$_POST['src'];
			$newsrc=$_POST['newSrc'];
			if ($dest=="") $dest="(.*)";
			if ($newdest=="") $newdest="\\\\1";
			if ($src=="") $src="(.*)";
			if ($newsrc=="") $newsrc="\\\\1";
			$config=get_difference_from_defaults();
			$config=parameters($config,$direction);

			$isdnid=uniqid("ISDNZUISDN");
			
			//$qu=$ba->update("UPDATE dialplan SET fromId='$fromid', toId='127.0.0.1', dest='$dest', newDest='".$_POST['isdnid'].$newdest."', src='$src', newSrc='$newsrc', config='$config' WHERE isdnid='".$_POST['isdnid']."' and direction='isdn-sip'");
			//$qu=$ba->update("UPDATE dialplan SET fromId='127.0.0.1', toId='$toid', dest='".$_POST['isdnid']."(.*)', newDest='\\\\1', src='(.*)', newSrc='\\\\1', config='$config' WHERE isdnid='".$_POST['isdnid']."' and direction='sip-isdn'");
			
			
			$ba->insert_("insert into dialplan (direction, fromId, toId, dest, newDest, src, newSrc, config, isdnid) VALUES ('isdn-sip', '$fromid', '127.0.0.1', '$dest', '".$isdnid. $newdest.  "', '$src', '$newsrc', '$config', '$isdnid')");
			$ba->insert_("insert into dialplan (direction, fromId, toId, dest, newDest, src, newSrc, config, isdnid) VALUES ('sip-isdn', '127.0.0.1', '$toid', '".$isdnid."(.*)', '\\\\1', '(.*)', '\\\\1', '$config', '$isdnid')");
		}
		$query = $ba->select("select option from activate");
		while ($entry = $ba->fetch_array($query)) {
			if ($entry['option'] <= 1)
				$query = $ba->update("UPDATE activate SET option=1");
		}
		if (!$ba->is_error()) {
			echo "<script>window.opener.location='../index.php?m=dialplan&start=" . $page . "'</script>";
			echo "<script>this.window.close();</script>";

		} else {
			echo "<script>alert(\"" . $ba->error() . "\");</script>";
		}
	}
}
?>
