<?php
@session_start();
if (!isset($_SESSION['beroari_time'])){
	 echo "<script>this.window.close();</script>";
}elseif((isset($_SESSION['beroari_time']))&&(($_SESSION['beroari_time']+1200)<time())){
	@session_unset();
	@session_destroy();
	echo "<script>window.opener.location='../index.php'</script>";
	echo "<script>this.window.close();</script>";
}else{
	$_SESSION['beroari_time']=time();
	chdir("..");

	include "./includes/variables.php";
	include "./misc/database.php";
	require_once "./includes/isgwtelnet.php";
	$ba= new beroAri();
	
	//Liefert ein Array mit den Defaultwerten des Configstrings
	function get_isgw_defaults() {
		$isgw = new isgwtelnet();
		$result=$isgw->isgw_login();
		if ($result!=false){
			$dialplanc=$isgw->isgw_dialplanconfig();
		$zeilen=split("\n",$dialplanc);
		}
		return $zeilen;
	}
		
	function get_difference_from_defaults() {
		foreach (array_keys($_POST) as $key){
			//Wenn die gespeicherte Daten in der POST Variable zu dem configstring gehören 
			if (stripos($key,'config_')!==false){
				$k=str_replace("config_", "", $key);
				$zeilen=get_isgw_defaults();
				foreach ($zeilen as $zeile){
					if (stripos($zeile,'[')===0){
						preg_match("/\[(?<bez>.)\]\[(?<name>.+)\] (?<desc>.+) (?<def>.+)/",$zeile,$res);
						if (($res['name']==$k) && ($_POST[$key]!="") && ($res['bez']=="s")){
							if ((($_POST[$key]=="\"\"") || ($_POST[$key]=="\'\'")) && ($config!='')) $config.=",".$res['name']."=";
							elseif 	((($_POST[$key]=="\"\"") || ($_POST[$key]=="\'\'")) && ($config=='')) $config.=$res['name']."=";
							elseif ($config!='') $config.=",".$res['name']."=".$_POST[$key];
							else $config.=$res['name']."=".$_POST[$key];
						}
					}
				}
			}	
		}
		return $config;
	}

	function parameters($config){
			//EA
			if (isset($_POST['ea']) && $config!=""){
				$config.=",ea=1";
			}elseif(isset($_POST['ea']) && $config==""){
				$config.="ea=1";
			}elseif(!isset($_POST['ea']) && $config!=""){
				$config.=",ea=0";
			}elseif(!isset($_POST['ea']) && $config==""){
				$config.="ea=0";
			}
			
			//T.38
			if (isset($_POST['t38'])){
				$config.=",t38=1";
			}elseif(!isset($_POST['t38'])){
				$config.=",t38=0";
			}
			
			//IE on SIP
			if (isset($_POST['ie_on_sip'])){
				$config.=",ie_on_sip=1";
			}elseif(!isset($_POST['ie_on_sip'])){
				$config.=",ie_on_sip=0";
			}
			
			//ALLOW SIP 183 WITHOUT SDP
			if (isset($_POST['allow_sip_183_without_sdp'])){
				$config.=",allow_sip_183_without_sdp=1";
			}elseif(!isset($_POST['allow_sip_183_without_sdp'])){
				$config.=",allow_sip_183_without_sdp=0";
			}
			
			//WAIT FOR CANCEL
			if (isset($_POST['wait_for_cancel'])){
				$config.=",wait_for_cancel=1";
			}elseif(!isset($_POST['wait_for_cancel'])){
				$config.=",wait_for_cancel=0";
			}
			
			//CLIR on SIP
			if (isset($_POST['clir_on_sip']))	$config.=",clir_on_sip=".$_POST['clir_on_sip'];
			
			//DTMF
			if (isset($_POST['dtmfmode'])) $config.=",dtmfmode=".$_POST['dtmfmode'];
			
			//CODECS
			$c="";
			for ($i=0;$i<count($_POST['codecs']);$i++){
				if ($c!="") $c.=":";
				$c.= $_POST['codecs'][$i];
			}
			if ($c!="")	$config.=",codecs=".$c;
			
			//FROM ID SETTING
			if (isset($_POST['from_id_setting']))	$config.=",from_id_setting=".$_POST['from_id_setting'];
			
			//DISPLAY NAME SETTING
			if (isset($_POST['display_name_setting']))	$config.=",display_name_setting=".$_POST['display_name_setting'];
			
			return $config;
	}

	if ($_POST['id_upd']){
		if ($ba->is_error()){
			die($ba->error());
		}
		if (strtolower($_POST['name'])=="general"){
			echo "<script> window.history.back(); alert('Invalid Name');</script>";
					return;
		}
		$query_comp=$ba->select("SELECT * FROM sip");
		while ($entry = $ba->fetch_array($query_comp)) {
			if ($_POST['id_upd']!=$entry['id']){
				if ($_POST['name']==$entry['name']){
					echo "<script> window.history.back(); alert('Invalid Name');</script>";
					return;
				}
			}
		}
		$name=$_POST['name'];
		$ser_addr=$_POST['server_address'];
		$user=$_POST['user'];
		$secret=$_POST['secret'];
		$type=$_POST['type'];
		$default=$_POST['default'];
		$stunserver=$_POST['stunserver'];
		$externip=$_POST['externip'];
		$config=get_difference_from_defaults();
		$config=parameters($config);
		$id=$_POST['id_upd'];
		if ($default==1){
			$query_new = $ba->update("UPDATE sip SET def='0'");
		}
		if ($default=="") $default=0;
		$query_new = $ba->update("UPDATE sip SET name='$name', server_address='$ser_addr',
						 user='$user', secret='$secret', type='$type', def='$default', 
						 config='$config', externip='$externip' WHERE id='$id'");
		if (!$ba->is_error()){
			$query=$ba->update("UPDATE dialplan SET fromId='p:".$name."' 
						where direction='sip-isdn' and fromId='p:".$_POST['alt_name']."'");
			$query=$ba->update("UPDATE dialplan SET toId='p:".$name."' 
						where direction='isdn-sip' and toId='p:".$_POST['alt_name']."'");
		}
		$query=$ba->select("select option from activate where id='activate'");
		while($entry = $ba->fetch_array($query)){
			if ($entry['option'] <= 1) $query =  $ba->update("UPDATE activate SET option=1 where id='activate'");
		}
		if (!$ba->is_error()){
			echo "<script>window.opener.location='../index.php?m=sip'</script>";
			echo "<script>this.window.close();</script>";

		}else{
			echo "<script>alert(".$ba->error().");</script>";
		}
	}else{
		if (($_POST['name'])&&($_POST['server_address']))
		{
			if ($ba->is_error()){
				die($ba->error());
			}
			if (strtolower($_POST['name'])=="general"){
				echo "<script> window.history.back(); alert('Invalid Name');</script>";
				return;
			}
			$query_comp=$ba->select("SELECT name FROM sip");
			while ($entry = $ba->fetch_array($query_comp)) {
				if ($_POST['name']==$entry['name']){
					echo "<script> window.history.back(); alert('Invalid Name');</script>";
					return;
				}
			}
			$name=$_POST['name'];
			$ser_addr=$_POST['server_address'];
			$user=$_POST['user'];
			$secret=$_POST['secret'];
			$type=$_POST['type'];
			$default=$_POST['default'];
			if ($default=="") $default=0;
			$stunserver=$_POST['stunserver'];
			$externip=$_POST['externip'];
			$config=get_difference_from_defaults();
			$config=parameters($config);

			if ($default==1){
				$query_new = $ba->update("UPDATE sip SET def='0'");
			}
			$query_new = $ba->insert_("INSERT INTO sip (name, server_address, user, secret, type, def, config,externip) 
									VALUES ('$name','$ser_addr', '$user', '$secret', '$type','$default','$config','$externip')");
			$query=$ba->select("select option from activate where id='activate'");
			while($entry = $ba->fetch_array($query)){
				if ($entry['option'] <= 1) $query =  $ba->update("UPDATE activate SET option=1 where id='activate'");
			}
			if (!$ba->is_error()){
				echo "<script>window.opener.location='../index.php?m=sip'</script>";
				echo "<script>this.window.close();</script>";

			}else{
				echo "<script>alert(".$ba->error().");</script>";
			}

		}else if ($_POST['submit']=="Save"){
			echo "<script> window.history.back(); alert('You must fill all the fields')</script>";
		}
	}
}

?>
