<?php
/**
 * Klasse Prosivioning
 * TFTP oder HTTP Einstellungen
 */

class Provisioning {
	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	function display($args) {

		// args
		$m = $_GET['m'];
		include('./includes/header.php');
		$prov_table = $this->dynamic_table();
		// build page content
		$ret.="<script>
		function tftp_http(index){
				if (index==0){
					document.getElementById('use_boot_http').disabled=true;
					document.getElementById('http_host').style.display='none';
					document.getElementById('http_url').style.display='none';
					document.getElementById('http_boot').style.display='none';
					document.getElementById('tftp_host').style.display='';
					document.getElementById('tftp_url').style.display='';
					document.getElementById('tftp_boot').style.display='';
					document.getElementById('use_boot_tftp').disabled=false;
					
				}else if (index==1){
					document.getElementById('http_host').style.display='';
					document.getElementById('http_url').style.display='';
					document.getElementById('http_boot').style.display='';
					document.getElementById('tftp_host').style.display='none';
					document.getElementById('tftp_url').style.display='none';
					document.getElementById('tftp_boot').style.display='none';
					document.getElementById('use_boot_tftp').disabled=true;
					document.getElementById('use_boot_http').disabled=false;
				}
				
			}
			</script>";
		$ret .= "
					<form class='extensions_form' name='provisioning' action='' method='POST'>
					<input type=hidden name=m value=" . $m . ">
					<input type=hidden name=a value='save'>
					<br>
					" . $prov_table;

		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}


	
	
	/*
	 * Funktion dynamic_table
	 */

	function dynamic_table() {
		//Wenn man Änderugen von der Daten macht werden die in der Tabelle der Datenbank
		//aktualisiert
		
		include '/usr/local/php/beroConf.php';
		$bc = new beroConf('root');
		if ($_POST['action']=='save'){
			if (isset($_POST['use_boot_prov'])) $bc->set("root", "use-boot-prov", "yes");
			else $bc->set("root", "use-boot-prov", "no");
			if ($_POST['password']!=""){
				@unlink("/usr/conf/apiusers.conf");
				$handle = fopen("/usr/conf/apiusers.conf","w");
   				fputs($handle, "admin:".$_POST['password']);
    	 		fclose($handle);
			}
		}
		if (isset($_POST['tftp_host']) && isset($_POST['tftp_url']) && $_POST['prov_opt']=="tftp") {
			if (($_POST['tftp_host']=="" && $_POST['tftp_url']=="") || 
				($_POST['tftp_host']!="" && $_POST['tftp_url']=="") || 
				($_POST['tftp_host']!="" && $_POST['tftp_url']!="")) {
				$bc->set("root", "tftp-host", $_POST['tftp_host']);
				$bc->set("root", "tftp-url", $_POST['tftp_url']);
				$bc->set("root", "provisioning-option", $_POST['prov_opt']);
			}else{
				echo "<script>alert('TFTP Host is a required Field');</script>";
			}		
		}elseif(isset($_POST['http_host']) && isset($_POST['http_url']) && $_POST['prov_opt']=="http"){
			if (($_POST['http_host']=="" && $_POST['http_url']=="") || 
				($_POST['http_host']!="" && $_POST['http_url']=="") || 
				($_POST['http_host']!="" && $_POST['http_url']!="")) {
				$bc->set("root", "http-host", $_POST['http_host']);
				$bc->set("root", "http-url", $_POST['http_url']);
				$bc->set("root", "provisioning-option", $_POST['prov_opt']);
			}else{
				echo "<script>alert('HTTP Host is a required Field');</script>";
			}
		}

		$zeile = @file("/usr/conf/apiusers.conf");
     	
   		$tmp=split(":",$zeile[0]);
   		$password=$tmp[1];
   		$select_opt="<select name='prov_opt' id='prov_opt' onchange='tftp_http(prov_opt.selectedIndex);'>";
   		if ($bc->get('root','provisioning-option')=="http"){
   			$select_opt.="<option value='tftp'>tftp</option>
   						<option value='http' selected>http</option>";
		}else{
			$select_opt.="<option value='tftp'>tftp</option>
   						<option value='http'>http</option>";
		}
		$select_opt.="</select>";

		$table = "<table class='contenttoc' id='table'>
					<tr>
					<th colspan='2'>Provisioning settings</th>
					</tr>
					<tr>
					<td><b>Provisioning Options:</b></td>
					<td>".$select_opt."</td>
					</tr>
					<tr id='tftp_host'>
					<td><b>TFTP Host:</b></td>
					<td><input type='text' name='tftp_host' value='" . $bc->get('root','tftp-host') . "' onmouseover=\"Tip('" . PROVISIONING_TFTP_HOST . "')\" onmouseout='UnTip()'></td>
					</tr>
					<tr id='tftp_url'>
					<td><b>TFTP Url:</b></td>
					<td><input type='text' name='tftp_url' value='" . $bc->get('root','tftp-url')  . "' onmouseover=\"Tip('" . PROVISIONING_TFTP_URL . "')\" onmouseout='UnTip()'></td>
					</tr>
					<tr id='tftp_boot'>
					<td><b>Use boot TFTP:</b></td>
					<td>";
					if ($bc->get('root','use-boot-prov')=="yes") $table.="<input type='checkbox' id='use_boot_tftp' name='use_boot_prov' value='yes' checked>";
					else $table.="<input type='checkbox' id='use_boot_tftp' name='use_boot_prov' value='yes'>";
		$table.="</td>
					<tr id='http_host'>
					<td><b>HTTP Host:</b></td>
					<td><input type='text' name='http_host' value='" . $bc->get('root','http-host') . "' onmouseover=\"Tip('" . PROVISIONING_TFTP_HOST . "')\" onmouseout='UnTip()'></td>
					</tr>
					<tr id='http_url'>
					<td><b>HTTP Url:</b></td>
					<td><input type='text' name='http_url' value='" . $bc->get('root','http-url')  . "' onmouseover=\"Tip('" . PROVISIONING_TFTP_URL . "')\" onmouseout='UnTip()'></td>
					</tr>
					<tr id='http_boot'>
					<td><b>Use boot HTTP:</b></td>
					<td>";
					if ($bc->get('root','use-boot-prov')=="yes") $table.="<input type='checkbox' id='use_boot_http' name='use_boot_prov' value='yes' checked>";
					else $table.="<input type='checkbox' id='use_boot_http' name='use_boot_prov' value='yes'>";
		$table.="</td>
					</tr>
					<tr>
					<td><b>API Password:</b></td>
					<td><input type='text' name='password' value='".$password."' onmouseover=\"Tip('" . PROVISIONING_API_PASS . "')\" onmouseout='UnTip()'></td>
					</tr>
					<tr>
					<td colspan='2'><input type='hidden' name='action' value='save'>
					<input name='submit' type='submit' value='Save' onmouseover=\"Tip('" . PROVISIONING_SAVE . "')\" onmouseout='UnTip()'>
					</td>
					</tr>
					</table>
					<br>
					</form>
					<script type='text/javascript'>tftp_http(document.getElementById('prov_opt').selectedIndex);</script>";
		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf 					
		return $table;
	}

}
?>
