<?php


/**
 * Klasse Dialplan
 * Zeigt alle Einträge von der Tabelle dialplan der Datenbank
 */

class Dialplan {

	
	/*
	 * Funktion action
	 * wird aufgerufen um einen neuen Eintrag in der Datenbank zu schreiben 
	 */
	function action($args) {

		// args
		$m = $_GET['m'];
		$a = $_GET['a'];
		$start = $_GET['start'];
		
		if ($a = 'add') {
			echo "<script type=\"text/javascript\">new_window(\"./misc/dialplan_popup.php?logingroup=" . $_SESSION['beroari_group'] . "&start=" . $start . "\");</script>";
		}
	}

	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	function display($args) {

		include "./includes/functions.php";
		//Das Objekt funktions wird erzeugt um später die Navigationsleiste zu erzeugen.
		$functions = new functions();

		// args
		$m = $_GET['m'];
		$q = $_GET['q'];
		$start = $_GET['start'];
		$next_del=0;
		$next_add=0;
		//ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		$query = $ba->select('SELECT * FROM dialplan');
		$record_count = sqlite_num_rows($query);
		$start = $start == '' ? 0 : $start;
		$span = 15;
				
		$next_del=$start;
		$test=$record_count/$span;
		$test=(int)$test;
		if ($record_count==0){
			$next_add=0;
		}else{
			$next_add=($test*$span);			
		}
		
		if ($start+$span<$record_count){
			$next_del=$start;
		}else{
			$rest=$record_count%$span;
			if ($record_count%$span==1){
				$next_del=$start-$span;
				if ($next_del<0)$next_del=0;
			}else{
				$next_del=$start;
			}
		}
		/*		
		echo "START " .  $start . "<br>";	
		echo "SPAN " .  $span . "<br>";	
		echo "TEST " .  $test . "<br>";	
		echo "REST " .  $rest . "<br>";	
		echo "ADD " .  $next_add . " rc " . $record_count . "<br>";	
		echo "DEL " .  $next_del . " rc " . $record_count . "<br>";	
		*/
		$dialplan_table = $this->dynamic_table($next_del,$span,$next_add);
		include('./includes/header.php');
		// build page content
		$ret .= "
			<script>
				function del(table,option, from, to,op,pos){
					
					
					conf = confirm('Do you want to delete the entry: From ID '+from+', To ID '+to+'?');
					if (conf==false)
						return false;
					else
						if(op=='isdnid') window.location='./misc/delete.php?isdnid='+option+'&table='+table+'&start='+pos;
						if(op=='id') window.location='./misc/delete.php?id='+option+'&table='+table+'&start='+pos;
				}
			</script>
			<form class='extensions_form' name='dialplan' action='' method='GET'>
			<input type=hidden name=m value=" . $m . ">
			<input type=hidden name=f value='action'>
			<input type=hidden name=a value='add'>
			<input type=hidden name=start value=" . $next_add . ">
			<br>
			" . $dialplan_table . "
			<br>
			<input name='submit' type='submit' value='Add' onmouseover=\"Tip('" . DIALPLAN_MOD_INBOUND_ADD . "')\" onmouseout='UnTip()'>
			</form>";

		//Erzeugung der Navigationsleiste.

		
		$url_opts = array ();
		$url_opts['number'] = $_GET['number'];
		$ret .= $functions->displayNavigationBlock($m, $q, $url_opts, $start, $span, $record_count);

		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}

	/*
	 * Funktion dynamic_table
	 */
	function dynamic_table($next_del,$span,$next_add) {
		//ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		$start = $_GET['start'];
		$columns = $ba->column_type('dialplan');
		$i = 0;
		$misdnids=array();
		
		//Das Header der Tabelle sind die Spaltennamen von dialplan
		foreach ($columns as $column => $type) {
			if (($column != 'id') && ($column != 'config') && ($column != 'isdnid')) {
				$cols_name[$i] = $column;
				if ($column == "direction")
					$column = "Direction";
				if ($column == "fromId")
					$column = "From ID";
				if ($column == "toId")
					$column = "To ID";
				if ($column == "dest")
					$column = "Destination";
				if ($column == "newDest")
					$column = "New Destination";
				if ($column == "src")
					$column = "Source";
				if ($column == "newSrc")
					$column = "New Source";
				$cols .= "<th class='contenttoc'>" . $column . "</th>";
				$i++;
			}
		}
		$i = 0;
		$cols .= "<th class='contenttoc'>Position</th>";
		
		/*Die Einträge werden von der Tabelle dialplan gelesen, formatiert und in einer
		  Tabelle geschrieben, zusätzlich werden 2 Knöpfe eingebaut: modify und delete*/
		$page = (($start / $span) + 1);
		if (!$start)
			$start = 0;
		$id = 0;
		
		for ($j = $page; $j <= $page; $j++) {
			$query = $ba->select(' SELECT * from dialplan ORDER BY id asc limit ' . $span .' offset ' . $start);
			$rows = '';
		
			while ($entry = $ba->fetch_array($query)) {
				//Die Tabelle mit allen Eiträgen "from ISDN"
				
				if ($entry['isdnid']!="" && !in_array($entry['isdnid'],$misdnids)){
					
					//exit;
					$rows .= "<tr>";
					array_push($misdnids,$entry['isdnid']);
					$q = $ba->select("select fromId, dest, src, id, newDest, newSrc from dialplan where isdnid='".$entry['isdnid']."' and direction='isdn-sip'");
					$en=$ba->fetch_array($q);
					$q1 = $ba->select("select toId from dialplan where isdnid='".$entry['isdnid']."' and direction='sip-isdn'");
					$en1=$ba->fetch_array($q1);
					$rows .= "<td>isdn-isdn</td>";
					$rows .= "<td>" . stripslashes($en['fromId']) . "</td>";
					$rows .= "<td>" . stripslashes($en1['toId']) . "</td>";
					$rows .= "<td>" . stripslashes($en['dest']) . "</td>";
					$newDest=str_replace($entry['isdnid'],'',$en['newDest']);
					$rows .= "<td>" . stripslashes($newDest) . "</td>";
					$rows .= "<td>" . stripslashes($en['src']) . "</td>";
					$rows .= "<td>" . stripslashes($en['newSrc']) . "</td>";
					$rows.="<td><a href='misc/up.php?id=".$en['id']."&isdnid=".$entry['isdnid']."&start=" . $start ."'><img src='./includes/images/up.png'></a>&nbsp;&nbsp;<a href='misc/down.php?id=".$en['id']."&isdnid=".$entry['isdnid']. "&start=" . $start ."'><img src='./includes/images/down.png'></a></td></td>";
					$id = $entry['id'];
													
					$rows .= "<td class='buttons' bgcolor='#DACECE'><font size='3'>
					<a class='popup_download' onclick=\"javascript:new_window('./misc/dialplan_popup.php?id=".$id."&isdnid=".$entry['isdnid']. "&start=" . $start . 
					"')\" ><input type='button' value='modify' onmouseover=\"Tip('" .
					DIALPLAN_MOD_INBOUND_MODIFY . "')\" onmouseout='UnTip()'></a>" .
					"&nbsp;<a class='popup_download' onclick=\"javascript:new_window('./misc/dialplan_popup.php?copy=".$id."&isdnid=".$entry['isdnid'] . "&start=" . $next_add .
					 "')\" ><input type='button' value='copy' onmouseover=\"Tip('" .
                	DIALPLAN_MOD_INBOUND_COPY . "')\" onmouseout='UnTip()'></a>" .
                	"&nbsp;<input type='button' value='delete' 
					onclick=\"del('dialplan','".$entry['isdnid']."','".$en['fromId']."','".$en1['toId']."','isdnid','" .  $next_del . "')\" onmouseover=\"Tip('" .
					DIALPLAN_MOD_INBOUND_DELETE . "')\" onmouseout='UnTip()'></font></td></tr>";
					
				}elseif ($entry['isdnid']!="" && in_array($entry['isdnid'],$misdnids)){				
					continue;
				}else{
					$rows .= "<tr>";
					$count = sqlite_num_fields($query);
					for ($i = 0; $i < ($count - 3); $i++) {
						$col_name = $cols_name[$i];
						$rows .= "<td>" . stripslashes($entry[$col_name]) . "</td>";
					}

					$rows.="<td><a href='misc/up.php?id=".$entry['id']. "&start=" . $start ."'><img src='./includes/images/up.png'></a>&nbsp;&nbsp;<a href='misc/down.php?id=".$entry['id']. "&start=" . $start . "'><img src='./includes/images/down.png'></a></td></td>";
					$id = $entry['id'];
					$rows .= "<td class='buttons' bgcolor='#DACECE'><font size='3'>
					<a class='popup_download' onclick=\"javascript:new_window('./misc/dialplan_popup.php?id=" .
					$entry['id'] . "&start=" . $start . "')\" ><input type='button' value='modify' onmouseover=\"Tip('" .
					DIALPLAN_MOD_INBOUND_MODIFY . "')\" onmouseout='UnTip()'></a>" .
					"&nbsp;<a class='popup_download' onclick=\"javascript:new_window('./misc/dialplan_popup.php?copy=" .
    	            $entry['id'] . "&start=" . $next_add . "')\" ><input type='button' value='copy' onmouseover=\"Tip('" .
        	        DIALPLAN_MOD_INBOUND_COPY . "')\" onmouseout='UnTip()'></a>" .
            	    "&nbsp;<input type='button' value='delete' 
					onclick=\"del('dialplan','" . $id . "','".$entry['fromId']."','".$entry['toId']."','id','" .  $next_del . "');\" onmouseover=\"Tip('" .
					DIALPLAN_MOD_INBOUND_DELETE . "')\" onmouseout='UnTip()'></font></td></tr>";
			}
			}
		}
		//Die Tabelle mit allen Eintägen "from SIP"
		$table = "<table class='contenttoc' id='table'><tr>" . $cols . "<th></th></tr>" . $rows . "</table>";
		//Rückgabe: Erzeugte Tabelle mit den Einträgen der Tabelle dialplan der Datenbank
		return $table;
	}

}
?>
