<?php


/**
 * Klasse Idsn_hw (ISDN Hardware)
 * Zeigt die Hardware configuration von ISDN (Die Kartennamen) und eine Knopf
 * um die Einstellungrn zu ändern
 */

class Isdn_hw {

	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	
	public static $show_master=0;
	public function display($args) {
		

		// $m ist der Name der Module
		$m = $_GET['m'];
		$q = $_GET['q'];
		$start = $_GET['start'];
		include('./includes/header.php');

		if ($_POST['id_upd']){
		if ($_POST['master_li0']=="0" && $_POST['master_li1']=="0"){
			$ret.= "<script>alert('2 Lineinterfaces cannot be slave')</script>";
		}else{
			$database = new beroAri();
			$query_new = $database->update("UPDATE isdn SET clock=0");
			if (isset($_POST['sync_li0'])) $database->update("UPDATE isdn SET clock=1 WHERE port='".$_POST['sync_li0']."'");
			if (isset($_POST['sync_li1'])) $database->update("UPDATE isdn SET clock=1 WHERE port='".$_POST['sync_li1']."'");
					
			$revision=exec('sed -ne "s/.*revision=\(.*\)/\1/p" /proc/cmdline');
			if (isset($_POST['portswitch']) && $revision!="1.80"){
				$q=$database->select("SELECT value from key_val WHERE key='portswitch'");
				if (sqlite_fetch_single($q)!=""){
					$database->update("UPDATE key_val set value=1 WHERE key='portswitch'");
				}else{
					$database->insert_("INSERT into key_val (key,value) VALUES('portswitch',1)");
				}
			}elseif (!isset($_POST['portswitch']) && $revision!="1.80"){
				$q=$database->select("SELECT value from key_val WHERE key='portswitch'");
				if (sqlite_fetch_single($q)!=""){
					$database->update("UPDATE key_val set value=0 WHERE key='portswitch'");
				}else{
					$database->insert_("INSERT into key_val (key,value) VALUES('portswitch',0)");
				}
			}

			$id=$_POST['id_upd'];
			for ($i=0;$i<count($id);$i++){
				$id_upd=$id[$i];
				$mode="mode".$id_upd;
				$mode_id=$_POST[$mode];
				$ptp="ptp".$id_upd;
				$ptp_id=$_POST[$ptp];
				$lt="lt".$id_upd;
				$lt_id=$_POST[$lt];
				if ($ptp_id==""){
					$ptp_id="1";
				}
				if ($lt_id==""){
					$lt_id="0";
				}
				$query_upd = $database->update("UPDATE isdn SET ntteHW='".$mode_id."', ntteSW='".$mode_id."', ptp='".$ptp_id."', lt='".$lt_id."' WHERE port='".$id_upd."'");
			}
			if ($_POST['master_li0']=="1" || !isset($_POST['master_li0'])) $database->update("UPDATE isdn SET master='1' where lif='0' ");
			else $database->update("UPDATE isdn SET master='0' where lif='0' ");
			if ($_POST['master_li1']=="1" || !isset($_POST['master_li1'])) $database->update("UPDATE isdn SET master='1' where lif='1' ");
			else $database->update("UPDATE isdn SET master='0' where lif='1' ");

			$query=$database->select("select option from activate where id='activate'");
			while($entry = $database->fetch_array($query)){
				if ($entry['option'] <= 3){
					$query =  $database->update("UPDATE activate SET option=3 where id='activate'");
					$ret.= "<script>aktivieren(1,'isdn_hw','3');</script>";
				}
			}
		
		}
		}
		
		
		
		
		
		$isdn_hw_table = $this->dynamic_table();
		// build page content
		$ret .= "
					<form class='isdnhw_form' name='isdn_hw' action='' method='POST'>
					<input type=hidden name=m value=" . $m . ">
					<br>
					" . $isdn_hw_table . "
					<br>
					</form>";
	
		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}
	
	public function mode ($ba,$act_mode,$id){
                if ($act_mode=='te'){
			$mode.="<option value='nt'>nt<br>";
                        $mode.="<option value='te' selected>te</option><br>";
                }else{
			$mode.="<option value='nt' selected>nt<br>";
                        $mode.="<option value='te'>te</option><br>";
                }
        return $mode;
	}

	/*
	 * Funktion dynamic_table
	 */
	public function dynamic_table() {
		/*
		 * Isdn Konfiguration für die "Karte"
		 */
		//Ein neues Datenbankobjekt von der Datenbank.
						
		$form_elements.= "";

		$database = new beroAri();
	
		$q=$database->select("select type, lif, master from isdn group by type,lif, master order by lif");
		$i=0;
		while ($ent=$database->fetch_array($q)){
			$li[$i]=$ent['lif'];
			$type[$i]=$ent['type'];
			$i++;
		}
		if (isset($li[0]) && isset($li[1])){
			$show_master=1;
		}

		$q=$database->select("select type, lif, master from isdn group by type,lif, master order by lif");
		while ($ent=$database->fetch_array($q)){
			if ($ent['type']!="bf1E1" && $ent['type']!="bf2E1"){
				$form_elements.="<br/><br/><table class='contenttoc' width='90%'>
					<tr><th colspan='5'><center>Card Type:&nbsp;".$ent['type'].
					"&nbsp;&nbsp;Line Interface:&nbsp;".$ent['lif']."&nbsp;&nbsp;";
			}else{
				$form_elements.="<br/><br/><table class='contenttoc' width='90%'>
					<tr><th colspan='4'><center>Card Type:&nbsp;".$ent['type'].
					"&nbsp;&nbsp;Line Interface:&nbsp;".$ent['lif']."&nbsp;&nbsp;";
				
			}
			if ($show_master==1){
				$form_elements.="Master:&nbsp;";
				if ($ent['master']==1) $form_elements.="<select name='master_li".$ent['lif']."' onchange='check_master()'>
													<option value='1' selected>Master</option>
													<option value='0'>Slave</option>
													</select>";
				else $form_elements.="<select name='master_li".$ent['lif']."' onchange='check_master()'>
									<option value='1'>Master</option>
									<option value='0' selected>Slave</option>
									</select>";
			}
			
			$form_elements.="<span id='sync_port_li".$ent['lif']."'>&nbsp;&nbsp;Synchronization port:&nbsp<select name='sync_li".$ent['lif']."' onmouseover=\"Tip('".ISDNHW_MASTER."')\" onmouseout='UnTip()'>";
			$query=$database->select("select port, clock from isdn where lif='".$ent['lif']."'");
			while ($entry=$database->fetch_array($query)){
				if ($entry['clock']==1)
				$form_elements.="<option value='".$entry['port']."' selected>".$entry['port']."</option>";
				else
				$form_elements.="<option value='".$entry['port']."'>".$entry['port']."</option>";
			}
			$form_elements.="</select></span></center></th></tr>";

			$query=$database->select("select * from isdn where lif='".$ent['lif']."'");
			while ($entry=$database->fetch_array($query)){
				if ($entry['type']!="bf1E1" && $entry['type']!="bf2E1"){
					$form_elements.="<tr>
						<td><b>Port:</b>&nbsp;".$entry['port']."&nbsp;</td>
						<td><b>Type:</b>&nbsp;<select name='mode".$entry['port']."' onmouseover=\"Tip('".ISDNHW_MODE."')\" 
						onmouseout='UnTip()'>".$this->mode($database,$entry['ntteHW'],$entry['port'])."</select></td>";
					if ($entry['ptp']==1){
						$form_elements.="<td><b>Protocol:</b>&nbsp;<select name='ptp".$entry['port']."' onmouseover=\"Tip('".ISDNHW_PTP."')\" onmouseout='UnTip()'>
							<option value=1 selected>PTP</option>
							<option value=0>PMP</option>
							</select>
							<input type=hidden name=id_upd[] value=".$entry['port']."></td>";
					}else{
						$form_elements.="<td><b>Protocol:</b>&nbsp;<select name='ptp".$entry['port']."' onmouseover=\"Tip('".ISDNHW_PTP."')\" onmouseout='UnTip()'>
							<option value=1>PTP</option>
							<option value=0 selected>PMP</option>
							</select>
							<input type=hidden name=id_upd[] value=".$entry['port']."></td>";
					}
					if ($entry['lt']==1){
						$form_elements.="<td><b>Termination:</b>&nbsp;<input type='checkbox' name='lt".$entry['port']."' checked value='1' onmouseover=\"Tip('".ISDNHW_LT."')\" onmouseout='UnTip()'></td>";
					}else{
						$form_elements.="<td><b>Termination:</b>&nbsp;<input type='checkbox' name='lt".$entry['port']."' value='1' onmouseover=\"Tip('".ISDNHW_LT."')\" onmouseout='UnTip()'></td>";
					}
					$i++;
				}else{
					$form_elements.="<tr>
						<!--
						<td><b>Card Type:</b>&nbsp;<input type=text value=".$entry['type']." size=7 disabled></td>
						<td><b>Line Interface:</b>&nbsp;<input type='text' value=".$entry['lif']." size=1 disabled></td>
						-->
						<td><b>Port:</b>&nbsp;".$entry['port']."&nbsp;</td>
						<td><b>Type:</b>&nbsp;<select name='mode".$entry['port']."' onmouseover=\"Tip('".ISDNHW_MODE."')\" 
						onmouseout='UnTip()'>".$this->mode($database,$entry['ntteHW'],$entry['port'])."</select></td>";
					$form_elements.="<td><b>Protocol:</b>&nbsp;<select name='ptp".$entry['port']."' onmouseover=\"Tip('".ISDNHW_PTPE1."')\" onmouseout='UnTip()'>
						<option value=1 selected>PTP</option>
						</select>
						<input type=hidden name=id_upd[] value=".$entry['port']."></td>";
					/*
					if ($entry['lt']==1){
						$form_elements.="<td><b>lt:</b>&nbsp;<input type='checkbox' name='lt".$entry['port']."' value='1' checked onmouseover=\"Tip('".ISDNHW_LT."')\" onmouseout='UnTip()'></td>";
					}else{
						$form_elements.="<td><b>Lt:</b>&nbsp;<input type='checkbox' name='lt".$entry['port']."' value='1' onmouseover=\"Tip('".ISDNHW_PTP."')\" onmouseout='UnTip()'></td>";
					}
					*/
					$i++;
				}
			}
			$form_elements.="</table>";
		}
		
		$revision=exec('sed -ne "s/.*revision=\(.*\)/\1/p" /proc/cmdline');
		$q=$database->select("select type, lif from isdn group by type,lif order by lif");
		$i=0;
		while ($ent=$database->fetch_array($q)){
			$li[$i]=$ent['lif'];
			$type[$i]=$ent['type'];
			$i++;
		}
		if ($type[0]=="bf4S0" && !isset($type[1]) && $revision!="1.80"){
			$form_elements.="<br/><br/>
							<table class='contenttoc' width='90%'>
							<tr>
								<th>Card Type:&nbsp;none&nbsp;&nbsp;Line Interface:&nbsp;1&nbsp;&nbsp;Portswitch:&nbsp;";
			$query=$database->select("select value from key_val where key='portswitch'");
			if (sqlite_fetch_single($query)==1){
				$form_elements.="<input type='checkbox' name='portswitch' value='1' checked>";
			}elseif (sqlite_fetch_single($query)==0){
				$form_elements.="<input type='checkbox' name='portswitch' value='1'>";
			}else{
				$form_elements.="<input type='checkbox' name='portswitch' value='1' checked>";
			}
			$form_elements.="</th>
							</tr>
							</table>";
		}

		$form_elements.="<br>
		<center><input type='submit' value='Save' onmouseover=\"Tip('".ISDNHW_SAVE."')\" 
		onmouseout='UnTip()'></center></form><script>
		function check_master(){
			if (document.getElementsByName('master_li0')[0].selectedIndex==1 && document.getElementsByName('master_li1')[0].selectedIndex==1){
				alert('2 Lineinterfaces cannot be slave');
				document.getElementsByName('master_li0')[0].selectedIndex=0;
			}
			
			if (document.getElementsByName('master_li0')[0].selectedIndex==0){
				document.isdn_hw.sync_li0.disabled=false;
				document.getElementById('sync_port_li0').style.display='';
			}else{
				document.isdn_hw.sync_li0.disabled=true;
				document.getElementById('sync_port_li0').style.display='none';
			}
			
			if (document.getElementsByName('master_li1')[0].selectedIndex==0){
				document.isdn_hw.sync_li1.disabled=false;
				document.getElementById('sync_port_li1').style.display='';
			}else{
				document.isdn_hw.sync_li1.disabled=true;
				document.getElementById('sync_port_li1').style.display='none';
			}
				
		}
		check_master();
		</script>";

		return $form_elements;
	}

}
?>
