<?php
/**
 * Klasse General
 * Zeigt algemeine Einstellungen von der isgw.conf Datei
 */

class Sip_general {
	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	function display($args) {

		// args
		$m = $_GET['m'];

		$sip_general_table = $this->dynamic_table();
		// build page content
		include('./includes/header.php');
		
		$ret .= "
					<form class='extensions_form' name='sip_general' action='' method='POST' onsubmit='return (sip_general_val(bindport.value,udpports.value) && verify_number(regrefresh.value, \"Registration intervall\"));'>
					<input type=hidden name=m value=" . $m . ">
					<input type=hidden name=a value='save'>
					<br>
					" . $sip_general_table;

		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}

	/*
	 * Der reguläre Ausdruck, der in der Datenbank gespeichert ist wird zurückgegeben 
	 * und nachher angezeigt.
	 */

	/*
	 * Die Adresse von dem Loging Server, die in der Datenbank gespeichert ist wird zurückgegeben 
	 * und nachher angezeigt.
	 */
	function bind_port() {
		$ba = new beroAri();
		$query = $ba->select("select bindport from sip_general");
		while ($entry = $ba->fetch_array($query)) {
			$ret = $entry['bindport'];
			return $ret;
		}
	}
	/*
	 * Die Udpports, die in der Datenbank gespeichert sind werden zurückgegeben 
	 * und nachher angezeigt.
	 */

	function udpports() {
		$ba = new beroAri();
		$query = $ba->select("select udpports from sip_general");
		while ($entry = $ba->fetch_array($query)) {
			return $entry['udpports'];
		}
	}

	function externip() {
		$ba = new beroAri();
		$query = $ba->select("select externip from sip_general");
		while ($entry = $ba->fetch_array($query)) {
			return $entry['externip'];
		}
	}
	
	function regrefresh(){
		$ba=new beroAri();
		if ($ba->get('regrefresh')!="")	return $ba->get('regrefresh');
		else return 60;
	}
	
	/*
	 * Funktion dynamic_table
	 */

	function dynamic_table() {
		//Wenn man Änderugen von der Daten macht werden die, in der Tabelle der Datenbank
		//aktualisiert
		$ba = new beroAri();
		if (isset($_POST['bindport']) && isset($_POST['udpports']) && isset($_POST['externip'])  && isset($_POST['regrefresh'])) {
			
			$ba->set("regrefresh",$_POST['regrefresh']);
			if ($_SESSION['beroari_username']=="beroAdmin" && isset($_POST['rtp_traffic'])) $ba->set("rtp_traffic","1");
			else if ($_SESSION['beroari_username']=="beroAdmin" && !isset($_POST['rtp_traffic'])) $ba->set("rtp_traffic","0");
			if ($_POST['sip_over_tcp']=="1") $ba->set("sip_over_tcp","1");
			else $ba->set("sip_over_tcp","0");
			$query = $ba->update("update sip_general set udpports='" . $_POST['udpports'] . "', bindport='" . $_POST['bindport'] . "', externip='" . $_POST['externip'] . "'");
			$query=$ba->select("select option from activate");
			while($entry = $ba->fetch_array($query)){
				if ($entry['option'] <= 2){
					$query =  $ba->update("UPDATE activate SET option=2");
					$table.= "<script>aktivieren(1,'sipg','2');</script>";
				}
			}
			
			
		}		
		$table .= "<table class='contenttoc' id='table'>
					<tr>
					<th colspan='2'>Sip General</th>
					</tr>
					<tr onmouseover=\"Tip('" . SIP_GENERAL_BINDPORT . "')\" onmouseout='UnTip()'>
					<td><b>Bind Port:</b></td>
					<td><input type='text' name='bindport' value='" . $this->bind_port() ."' ></td>
					</tr>
					<tr onmouseover=\"Tip('" . SIP_GENERAL_UDPPORTS . "')\" onmouseout='UnTip()'>
					<td><b>RTP Port Range:</b></td>
					<td><input type='text' name='udpports' value='" . $this->udpports() ."' ></td>
                                        </tr>
                                        <tr onmouseover=\"Tip('" . SIP_GENERAL_EXTERNIP . "')\" onmouseout='UnTip()'>
                                        <td><b>Extern IP:</b></td>
					<td><input type='text' name='externip' value='" . $this->externip() ."' ></td>
					</tr>
					<tr onmouseover=\"Tip('" . SIP_OVER_TCP . "')\" onmouseout='UnTip()'>
					<td><b>Use SIP over TCP</b></td>";
					if ($ba->get("sip_over_tcp")=="1" || $ba->get("sip_over_tcp")=="yes") 
						$table.="<td><input type='checkbox' name='sip_over_tcp' value='1'  checked/></td>";
					else
						$table.="<td><input type='checkbox' name='sip_over_tcp' value='1' /></td>";
					$table.="</tr>
					<tr onmouseover=\"Tip('" . SIP_GENERAL_REGREFRESH . "')\" onmouseout='UnTip()'>
					<td><b>Registration intervall:</b></td>
					<td><input type='text' name='regrefresh' value='" . $this->regrefresh() ."' ></td>
					</tr>";
					if ($_SESSION['beroari_username']=="beroAdmin"){
						if ($ba->get("rtp_traffic")=="1") 
							$table.='<tr><td><b>RTP Traffic</b></td><td><input type="checkbox" name="rtp_traffic" id="rtp_traffic" value="1" checked></td></tr>';
						else
							$table.='<tr><td><b>RTP Traffic</b></td><td><input type="checkbox" name="rtp_traffic" id="rtp_traffic" value="1"></td></tr>';
					}
					$table.="</table>
					<br>
					<input name='submit' type='submit' value='Save' onmouseover=\"Tip('" . SIP_GENERAL_SAVE . "')\" onmouseout='UnTip()'>
					</form>";
		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf 					
		return $table;
	}

}
?>
